/*

STRICQ - An Amiga, MUI Based, ICQ Clone.
Copyright (C) 1998-2000 Douglas F. McLaughlin

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Douglas F. McLaughlin - stricq@owlnet.net

*/

#ifndef MAKE_ID
#define MAKE_ID(a,b,c,d) ((ULONG) (a)<<24 | (ULONG) (b)<<16 | (ULONG) (c)<<8 | (ULONG) (d))
#endif

#define HOOK1(f) static struct Hook f ## Hook
#define HOOK2(f) InstallHook(& ## f ## Hook,f,ObjectApp)

#include <stdio.h>

#include <dos/dos.h>

#include <proto/dos.h>

#include "STRICQMUI.h"
#include "STRICQ_Cat.h"
#include "STRICQExtern.h"

#include "Hook_Utility.h"

#define Title(t)        { NM_TITLE, t, NULL, 0, 0, NULL }
#define Item(t,s,i)     { NM_ITEM, t, s, 0, 0, (APTR)i }
#define ItemBar         { NM_ITEM, NM_BARLABEL, NULL, 0, 0, NULL }
#define SubItem(t,s,i)  { NM_SUB, t, s, 0, 0, (APTR)i }
#define SubBar          { NM_SUB, NM_BARLABEL, NULL, 0, 0, NULL }
#define EndMenu         { NM_END, NULL, NULL, 0, 0, NULL }
#define ItCk(t,s,i,f)   { NM_ITEM, t, s, f, 0, (APTR)i }

/* #define mainanim "mui:images/TransferAnim/mainanim"
   */

enum {ID_ONLINE = 1L, ID_OFFLINE, ID_ABOUT, ID_QUIT, ID_PREFS, ID_MUI, ID_LOGWIN, ID_MSGWIN, ID_SAVECL, ID_SAVEPREF,
      ID_URLWIN, ID_INFOWIN, ID_NEWUIN, ID_ACTIVITY, ID_ABOUTMUI, ID_SAVEMSGS, ID_SEARCH, ID_HISTORY, ID_CONNECTIONS,
      ID_PAGER, ID_ERRWIN, ID_ICQPREFS, ID_RESETSOCKS};

enum {OID_UIN = 256L, OID_NICK, OID_PWD, OID_MSGNOTIFY, OID_ONCOLOR, OID_URLCMND, OID_AUTOONLINE, OID_AUTOLOG,
      OID_RECONNECT, OID_SMALLLIST, OID_AWAYMSG, OID_USEAWAY, OID_ONLINEMSG, OID_USEONLINE, OID_INVISIBLEMSG,
      OID_USEINVISIBLE, OID_NAMSG, OID_USENA, OID_FFCMSG, OID_USEFFC, OID_OCCUPIEDMSG, OID_USEOCCUPIED, OID_DNDMSG,
      OID_USEDND, OID_THESERVER, OID_THEPORT, OID_ONNOTIFY, OID_FIRST, OID_LAST, OID_EMAIL,
      OID_REQAUTH, OID_CITY, OID_COUNTRY, OID_STATE, OID_AGE, OID_SEX, OID_PHONE, OID_PAGE, OID_ABOUT, OID_MSGTIME,
      OID_SYSMSG, OID_STATUS, OID_MSGPARSE, OID_OFFNOTIFY, OID_OPENMSGWIN, OID_MSGPOPUP, OID_CHATNOTIFY, OID_SCRN2FRNT,
      OID_CHATBEEP, OID_NOMSGLOG, OID_ACTYSORT, OID_DLDIR, OID_FILEDIRECT, OID_WEBPRESENCE, OID_HIDEIP, OID_LAMP,
      OID_MULTILINE, OID_MSGPREPARSE, OID_ONSTARTUP, OID_ONSHUTDOWN, OID_TIMEZONE, OID_USEBEATS, OID_NOINPBUF,
      OID_UDPPKTS, OID_UDPDEBUG, OID_TCPPKTS, OID_TCPDEBUG, OID_SETSTATUS0, OID_TIMEDSTATUS0, OID_SETSTATUS1,
      OID_TIMEDSTATUS1, OID_SETSTATUS2, OID_TIMEDSTATUS2, OID_SETSTATUS3, OID_TIMEDSTATUS3, OID_SETSTATUS4,
      OID_TIMEDSTATUS4, OID_UDPVERSION, OID_HIDEEMAIL, OID_EMAIL2, OID_EMAILOLD, OID_STREETAD, OID_ZIPCODE, OID_FAX,
      OID_CELLULAR, OID_WORKAD, OID_WKCITY, OID_WKSTATE, OID_WKZIPCODE, OID_WKURL, OID_WKCOUNTRY, OID_CONAME, OID_DIVDEPT,
      OID_POSITION, OID_OCCUPATION, OID_WKPHONE, OID_WKFAX, OID_BDMONTH, OID_BDYEAR, OID_BDNOTIFY, OID_LANG1, OID_LANG2,
      OID_LANG3, OID_BDDAY, OID_AFFILICH1, OID_AFFILICY1, OID_KEYWORD1, OID_AFFILICH2, OID_AFFILICY2, OID_KEYWORD2,
      OID_AFFILICH3, OID_AFFILICY3, OID_KEYWORD3, OID_BACKGROUNDCH1, OID_BACKGROUNDCY1, OID_KEYWORD4,
      OID_BACKGROUNDCH2, OID_BACKGROUNDCY2, OID_KEYWORD5, OID_BACKGROUNDCH3, OID_BACKGROUNDCY3, OID_KEYWORD6,
      OID_SELCAT1, OID_SELCAT2, OID_SELCAT3, OID_SELCAT4, OID_PICTURE, OID_PICPRIVACIES, OID_PICPRIVACY};

struct MUI_CustomClass *mcc_Port, *mcc_Transfert, *mcc_Time, *mcc_Color, *mcc_Chat, *mcc_Cols;

// Static MOI....
static struct NewMenu STRICQMenu[] = {
// **  {NM_TITLE, "Project"      , 0 ,0,0,(APTR)0},
  Title(NULL),
//{NM_ITEM , "Register UIN" , 0 ,0,0,(APTR)ID_NEWUIN},
// ** {NM_ITEM , "Search UIN"   ,"S",0,0,(APTR)ID_SEARCH},
  Item(NULL,NULL,ID_SEARCH),
//**  {NM_ITEM , NM_BARLABEL    , 0 ,0,0,(APTR)0},
  ItemBar,
//{NM_ITEM , "Connect"      ,"N",0,0,(APTR)ID_ONLINE},
//{NM_ITEM , "Disconnect"   ,"F",0,0,(APTR)ID_OFFLINE},
// **  {NM_ITEM , "Reset Sockets","R",0,0,(APTR)ID_RESETSOCKS},
  Item(NULL,NULL,ID_RESETSOCKS),
//** {NM_ITEM , NM_BARLABEL    , 0 ,0,0,(APTR)0},
  ItemBar,
// **  {NM_ITEM , "About..."     ,"A",0,0,(APTR)ID_ABOUT},
  Item(NULL,NULL,ID_ABOUT),
// **  {NM_ITEM , "About MUI..." , 0 ,0,0,(APTR)ID_ABOUTMUI},
  Item(NULL,NULL,ID_ABOUTMUI),

// ** {NM_ITEM , NM_BARLABEL    , 0 ,0,0,(APTR)0},
  ItemBar,

// ** {NM_ITEM , "Quit"         ,"Q",0,0,(APTR)ID_QUIT},
  Item(NULL,NULL,ID_QUIT),

// ** {NM_TITLE, "Settings"    , 0 ,0,0,(APTR)0},
  Title(NULL),

// ** {NM_ITEM , "ICQ Prefs...","I",0,0,(APTR)ID_ICQPREFS},
  Item(NULL,NULL,ID_ICQPREFS),

// ** {NM_ITEM , "Save Prefs"  , 0 ,0,0,(APTR)ID_SAVEPREF},
  Item(NULL,NULL,ID_SAVEPREF),

// ** {NM_ITEM , NM_BARLABEL   , 0 ,0,0,(APTR)0},
  ItemBar,

// ** {NM_ITEM , "MUI..."      ,"M",0,0,(APTR)ID_MUI},
  Item(NULL,NULL,ID_MUI),

// ** {NM_TITLE, "Messages", 0 ,0,0,(APTR)0},
  Title(NULL),

// ** {NM_ITEM , "Save..." , 0 ,0,0,(APTR)ID_SAVEMSGS},
  Item(NULL,NULL,ID_SAVEMSGS),

// ** {NM_TITLE, "Windows"          , 0 ,0,0,(APTR)0},
  Title(NULL),

// ** {NM_ITEM , "Activity Log"     ,"1",0,0,(APTR)ID_ACTIVITY},
  Item(NULL,NULL,ID_ACTIVITY),

// ** {NM_ITEM , "Active Sockets"   ,"2",0,0,(APTR)ID_CONNECTIONS},
  Item(NULL,NULL,ID_CONNECTIONS),

// ** {NM_ITEM , "Errors"           ,"3",0,0,(APTR)ID_ERRWIN},
  Item(NULL,NULL,ID_ERRWIN),

// ** {NM_ITEM , "Message History"  ,"4",0,0,(APTR)ID_HISTORY},
  Item(NULL,NULL,ID_HISTORY),

// ** {NM_ITEM , "STRICQ Log"       ,"5",0,0,(APTR)ID_LOGWIN},
  Item(NULL,NULL,ID_LOGWIN),

// ** {NM_ITEM , "Incoming Messages","6",0,0,(APTR)ID_MSGWIN},
  Item(NULL,NULL,ID_MSGWIN),

// ** {NM_ITEM , "Pager Messages"   ,"7",0,0,(APTR)ID_PAGER},
  Item(NULL,NULL,ID_PAGER),

// ** {NM_ITEM , "System Message"   ,"8",0,0,(APTR)ID_URLWIN},
  Item(NULL,NULL,ID_URLWIN),

// ** {NM_ITEM , "User Information" ,"9",0,0,(APTR)ID_INFOWIN},
  Item(NULL,NULL,ID_INFOWIN),

// ** {NM_END,NULL,0,0,0,(APTR)0},
  EndMenu,
};


/* Fonctions necessary for Localization of the Menus&Arrays... */
extern void localize_array(char *array[])
{
    char **x;

    for(x=array;*x;x++)
        *x = (char *)((struct FC_String *)(*x))->msg;
}


static void UpdateStrings(void) {

  char ** strings2[] =
  {
      (char**) &msgMENU1,
      (char**) &msgMENU2,
      (char**) &msgMENU3,
      (char**) &msgMENU4,
      (char**) &msgMENU5,
      (char**) &msgMENU6,
      (char**) &msgMENU7,
      (char**) &msgMENU8,
      (char**) &msgMENU9,
      (char**) &msgMENU10,
      (char**) &msgMENU11,
      (char**) &msgMENU12,
      (char**) &msgMENU13,
      (char**) &msgMENU14,
      (char**) &msgMENU15,
      (char**) &msgMENU16,
      (char**) &msgMENU17,
      (char**) &msgMENU18,
      (char**) &msgMENU19,
      (char**) &msgMENU20,
      (char**) &msgMENU21,
      (char**) &msgMENU22,
    /*  (char**) &MsgMenu1_5,
      (char**) &MsgMenu1_6,
      (char**) &MsgMenu1_7,
      (char**) &MsgMenu1_8,
      (char**) &MsgMenu1_9,*/
};

 

 /* char ** strings[] =
  {
    (char**) &MsgMenu_2,
    (char**) &MsgMenu2_1,
    (char**) &MsgMenu2_2,

  }; */

//  struct NewMenu   *menuptr;
  struct NewMenu   *menuptr2;
//  char           ***stringptr;
  char           ***stringptr2;

/*  menuptr   = (struct NewMenu *) &Contexte; */
  menuptr2  = (struct NewMenu *) &STRICQMenu;
 /* stringptr = (char ***) &strings; */
  stringptr2= (char ***) &strings2;

 /* while(menuptr->nm_Type != NM_END)
  {
    if(menuptr->nm_Label == NULL)
    {
      if(strlen(**stringptr) != 0) {
        menuptr->nm_CommKey = **stringptr;
      }
      menuptr->nm_Label = **stringptr + strlen(**stringptr) + 1;
      stringptr++;
    }
    menuptr++;
  }
   */
  while(menuptr2->nm_Type != NM_END)
  {
    if(menuptr2->nm_Label == NULL)
    {
      if(strlen(**stringptr2) != 0) {
        menuptr2->nm_CommKey = **stringptr2;
      }
      menuptr2->nm_Label = **stringptr2 + strlen(**stringptr2) + 1;
      stringptr2++;
    }
    menuptr2++;
  }
}
/* char ** Statii[]= {
    (char **) &msgMENU1,
    (char **) &msgMENU2,
    (char **) &msgMENU3,
    };


 char *Statii[] = {"Online", "Invisible", "Not Available", "Free For Chat",
                  "Occupied", "Away", "Do Not Disturb", "OFFLINE", NULL};


char ***emilie;
emilie = (char ***) &statii;
*/

extern char *Statii[] = {
    (char*)_msgStatii1,
    (char*)_msgStatii2,
    (char*)_msgStatii3,
    (char*)_msgStatii4,
    (char*)_msgStatii5,
    (char*)_msgStatii6,
    (char*)_msgStatii7,
    (char*)_msgStatii8,
NULL
};


extern char *PagesInfo[] = {
    (char*)_msgPages1,
    (char*)_msgPages2,
NULL
};

// char *PagesInfo[]  = {"Basic Info", "Extended Info", NULL};

extern char *PagesOpts[] = {
    (char*)_msgOpts1,
    (char*)_msgOpts2,
NULL
};

// char *PagesOpts[]  = {"Options", "List", NULL};

extern char *PagesAway[] = {
    (char*)_msgPagesAway1,
    (char*)_msgPagesAway2,
NULL
};

//char *PagesAway[]  = {"Auto Reply", "Set Away", NULL};

extern char *PagesColor[] = {
    (char*)_msgPagesColor1,
    (char*)_msgPagesColor2,
NULL
};

//char *PagesColor[] = {"Status Color", "Chat Mode Color", NULL};

extern char *GroupPages[] = {
    (char*)_msgGroupPages1,
    (char*)_msgGroupPages2,
    (char*)_msgGroupPages3,
    (char*)_msgGroupPages4,
    (char*)_msgGroupPages5,
    (char*)_msgGroupPages6,
    (char*)_msgGroupPages7,
    (char*)_msgGroupPages8,
    (char*)_msgGroupPages9,
    (char*)_msgGroupPages10,
    (char*)_msgGroupPages11,
    (char*)_msgGroupPages12,
    (char*)_msgGroupPages13,
    (char*)_msgGroupPages14,
    (char*)_msgGroupPages15,
NULL
};

/*char *GroupPages[] = {"Main", "Home", "Work", "More", "Info/About", "Affiliations", "Interests", "Picture", "Security",
                      "Ignore", "Servers", "Notify", "Color", "Away", "Options", NULL};
  */

//static char *ABOUTPAGES[] = {"Version","Auteur","License",NULL};

extern char *AboutPages[] = {
    (char*)_msgAboutPage1,
    (char*)_msgAboutPage2,
    (char*)_msgAboutPage3,
NULL
};

extern char *Sex[] = {
    (char*)_msgSex1,
    (char*)_msgSex2,
    (char*)_msgSex3,
NULL
};


//char *Sex[] = {"Unspecified", "Female", "Male", NULL};

char *Lamps[] = {"Lamp.mcc", "TWFmultiLED.mcc", NULL};

char *UDPVersion[] = {"Version 2", "Version 5", NULL};

extern char *Months[] = {
    (char*)_msgMonths1,
    (char*)_msgMonths2,
    (char*)_msgMonths3,
    (char*)_msgMonths4,
    (char*)_msgMonths5,
    (char*)_msgMonths6,
    (char*)_msgMonths7,
    (char*)_msgMonths8,
    (char*)_msgMonths9,
    (char*)_msgMonths10,
    (char*)_msgMonths11,
    (char*)_msgMonths12,
    (char*)_msgMonths13,
NULL
};

//char *Months[] = {"N/A", "January", "February", "March", "April", "May", "June", "July", "August", "September", "October",
//                  "November", "December", NULL};

extern char *PicPrivacy[] = {
    (char*)_msgPicPrivacy1,
    (char*)_msgPicPrivacy2,
    (char*)_msgPicPrivacy3,
NULL
};

//char *PicPrivacy[]    = {"Auto send to users on my list", "Auto send to all users", "Show request", NULL};

extern char *Authorization[] = {
    (char*)_msgAuthorization1,
    (char*)_msgAuthorization2,
NULL
};

//char *Authorization[] = {"All users may add me to their contact list", "My authorization is required", NULL};

// nogfx

static char nogfx[40];

char splash[MAXNAMLEN], about[MAXNAMLEN], zodiac[MAXNAMLEN];

extern char *CountryNames[], *ChatColorNames[], *Occupations[], *Languages[], *Affiliations[], *Backgrounds[];


struct Hook AddMsgHook;
struct Hook RemMsgHook;
struct Hook CmpMsgHook;
struct Hook DisplayMsgHook;

struct Hook AddSessionHook;
struct Hook RemSessionHook;
struct Hook CmpSessionHook;
struct Hook DisplaySessionHook;

struct Hook GetUINInfoHook;
struct Hook GoURLHook;
struct Hook SendMsg2ICQaHook;
struct Hook SaveContactJumpHook;
struct Hook LoadContactJumpHook;
struct Hook LoadHistoryHook;
struct Hook SaveHistoryHook;
struct Hook DeleteHistoryHook;
struct Hook AcceptHook;
struct Hook RefuseHook;
struct Hook OpenChatReqWinHook;
struct Hook EndChatHook;
struct Hook Add2IgnoreHook;
struct Hook SetXferSpeedHook;
struct Hook SkipFileHook;
struct Hook AbortXferHook;
struct Hook KillXferWinHook;
struct Hook OpenFileDirectWinHook;
struct Hook ForwardMsgHook;
struct Hook ShareContactsHook;
struct Hook ChatWinStateHook;
struct Hook EndAllChatHook;
struct Hook SetBIUHook;
struct Hook SetLocalFColorHook;
struct Hook SetUserVisPrefsHook;


struct ObjApp *CreateApp(char *path)

{

BPTR lock;

int i;

struct ObjApp *ObjectApp;

static struct Hook AddOfflineHook;
static struct Hook RemOfflineHook;
static struct Hook CmpOfflineHook;
static struct Hook DisplayOfflineHook;

static struct Hook AddLogHook;
static struct Hook RemLogHook;
static struct Hook CmpLogHook;
static struct Hook DisplayLogHook;

static struct Hook AddActyHook;
static struct Hook RemActyHook;
static struct Hook CmpActyHook;
static struct Hook DisplayActyHook;

HOOK1(AddSock);
HOOK1(RemSock);
HOOK1(CmpSock);
HOOK1(DisplaySock);

HOOK1(AddCols);
HOOK1(RemCols);
HOOK1(CmpCols);
HOOK1(DisplayCols);

HOOK1(AddIgnore);
HOOK1(RemIgnore);
HOOK1(CmpIgnore);
HOOK1(DisplayIgnore);

HOOK1(AddFile);
HOOK1(RemFile);
HOOK1(CmpFile);
HOOK1(DisplayFile);

HOOK1(AddAddUIN);
HOOK1(RemAddUIN);
HOOK1(CmpAddUIN);
HOOK1(DisplayAddUIN);

HOOK1(AddErr);
HOOK1(RemErr);
HOOK1(CmpErr);
HOOK1(DisplayErr);

static struct Hook AddContactHook;
static struct Hook ConnectICQHook;
static struct Hook DisconnectICQHook;
static struct Hook ChangePWHook;
static struct Hook SendMessageHook;
static struct Hook SendMsg2ICQHook;
static struct Hook AddUpdateHook;
static struct Hook SetQuickToHook;
static struct Hook ChangeMyStatusHook;
static struct Hook SavePrefsHook;
static struct Hook AddServerHook;
static struct Hook ViewHistoryHook;
static struct Hook SendUInfo1Hook;
static struct Hook SendUInfo2Hook;
static struct Hook NewUINHook;
static struct Hook MakeFilenamesHook;
static struct Hook ChangeMyUINHook;
static struct Hook SaveMsgWinHook;

HOOK1(NewUserWin);
HOOK1(RemoveContact);
HOOK1(SendChatReq);
HOOK1(AddFiles2Send);
HOOK1(SetFileSendStats);
HOOK1(SendFileSend);
HOOK1(SetCountry);
HOOK1(GetAddUINInfo);
HOOK1(SaveErrors);
HOOK1(OpenEditIgnore);
HOOK1(SetIgnoreEdits);
HOOK1(ChangeZodiac);
HOOK1(ResetSockets);

HOOK1(RxStatus);
HOOK1(RxGetContact);
HOOK1(RxSendMessage);
HOOK1(RxWinControl);
HOOK1(RxAddFile);
HOOK1(RxFileDirect);
HOOK1(RxGetVersion);
HOOK1(RxDeleteUIN);
HOOK1(RxGetFiles);
HOOK1(RxAcceptChatFile);

static struct MUI_Command STRICQRexx[] = {
  {"STATUS"     ,"SET/K,GET/S,ALL/S,VAR/K"               ,4,&RxStatusHook},
  {"GETCONTACT" ,"UIN/K,ENTRY/K,SELECTED/S,TOTAL/S,VAR/K",5,&RxGetContactHook},
  {"SENDMESSAGE","UIN/K,MSG/K,URL/K,FILE/K,DEST/K"       ,5,&RxSendMessageHook},
  {"WINCONTROL" ,"WIN/K,OPEN/S,CLOSE/S,UIN/K"            ,4,&RxWinControlHook},
  {"ADDFILE"    ,"FILE/K,REMOVE/S,CLEAR/S"               ,3,&RxAddFileHook},
  {"FILEDIRECT" ,"UIN/K,SPEED/K,DESC/K"                  ,3,&RxFileDirectHook},
  {"GETVERSION" ,"FULL/S"                                ,1,&RxGetVersionHook},
  {"DELETEUIN"  ,"UIN/K"                                 ,1,&RxDeleteUINHook},
  {"GETFILES"   ,"VAR/K"                                 ,1,&RxGetFilesHook},
  {"ACCEPT"     ,"UIN/K,ACCEPT/S,DECLINE/S"              ,3,&RxAcceptChatFileHook},

  {NULL,NULL,NULL,NULL},
};

if (!(ObjectApp = AllocVec(sizeof(struct ObjApp),MEMF_CLEAR))) return(NULL);

InstallHook(&AddOfflineHook,AddOffline,ObjectApp);
InstallHook(&RemOfflineHook,RemOffline,ObjectApp);
InstallHook(&CmpOfflineHook,CmpOffline,ObjectApp);
InstallHook(&DisplayOfflineHook,DisplayOffline,ObjectApp);

InstallHook(&AddLogHook,AddLog,ObjectApp);
InstallHook(&RemLogHook,RemLog,ObjectApp);
InstallHook(&CmpLogHook,CmpLog,ObjectApp);
InstallHook(&DisplayLogHook,DisplayLog,ObjectApp);

InstallHook(&AddMsgHook,AddMsg,ObjectApp);
InstallHook(&RemMsgHook,RemMsg,ObjectApp);
InstallHook(&CmpMsgHook,CmpMsg,ObjectApp);
InstallHook(&DisplayMsgHook,DisplayMsg,ObjectApp);

InstallHook(&AddActyHook,AddActy,ObjectApp);
InstallHook(&RemActyHook,RemActy,ObjectApp);
InstallHook(&CmpActyHook,CmpActy,ObjectApp);
InstallHook(&DisplayActyHook,DisplayActy,ObjectApp);

HOOK2(AddSock);
HOOK2(RemSock);
HOOK2(CmpSock);
HOOK2(DisplaySock);

HOOK2(AddCols);
HOOK2(RemCols);
HOOK2(CmpCols);
HOOK2(DisplayCols);

HOOK2(AddIgnore);
HOOK2(RemIgnore);
HOOK2(CmpIgnore);
HOOK2(DisplayIgnore);

HOOK2(AddFile);
HOOK2(RemFile);
HOOK2(CmpFile);
HOOK2(DisplayFile);

HOOK2(AddAddUIN);
HOOK2(RemAddUIN);
HOOK2(CmpAddUIN);
HOOK2(DisplayAddUIN);

HOOK2(AddErr);
HOOK2(RemErr);
HOOK2(CmpErr);
HOOK2(DisplayErr);

HOOK2(AddSession);
HOOK2(RemSession);
HOOK2(CmpSession);
HOOK2(DisplaySession);

InstallHook(&GetUINInfoHook,GetUINInfo,ObjectApp);
InstallHook(&AddContactHook,AddContact,ObjectApp);
InstallHook(&ConnectICQHook,ConnectICQ,ObjectApp);
InstallHook(&DisconnectICQHook,DisconnectICQ,ObjectApp);
InstallHook(&ChangePWHook,ChangePW,ObjectApp);
InstallHook(&SendMessageHook,SendMessage,ObjectApp);
InstallHook(&SendMsg2ICQHook,SendMsg2ICQ,ObjectApp);
InstallHook(&AddUpdateHook,AddUpdate,ObjectApp);
InstallHook(&SetQuickToHook,SetQuickTo,ObjectApp);
InstallHook(&ChangeMyStatusHook,ChangeMyStatus,ObjectApp);
InstallHook(&SavePrefsHook,SavePrefs,ObjectApp);
InstallHook(&GoURLHook,GoURL,ObjectApp);
InstallHook(&AddServerHook,AddServer,ObjectApp);
InstallHook(&ViewHistoryHook,ViewHistory,ObjectApp);
InstallHook(&SendUInfo1Hook,SendUInfo1,ObjectApp);
InstallHook(&SendUInfo2Hook,SendUInfo2,ObjectApp);
InstallHook(&NewUINHook,NewUIN,ObjectApp);
InstallHook(&MakeFilenamesHook,MakeFilenames,ObjectApp);
InstallHook(&ChangeMyUINHook,ChangeMyUIN,ObjectApp);
InstallHook(&SaveMsgWinHook,SaveMsgWin,ObjectApp);
 
HOOK2(NewUserWin);
HOOK2(SendMsg2ICQa);
HOOK2(SaveContactJump);
HOOK2(LoadContactJump);
HOOK2(LoadHistory);
HOOK2(SaveHistory);
HOOK2(DeleteHistory);
HOOK2(RemoveContact);
HOOK2(SendChatReq);
HOOK2(Accept);
HOOK2(Refuse);
HOOK2(OpenChatReqWin);
HOOK2(EndChat);
HOOK2(Add2Ignore);
HOOK2(SetXferSpeed);
HOOK2(SkipFile);
HOOK2(AbortXfer);
HOOK2(KillXferWin);
HOOK2(OpenFileDirectWin);
HOOK2(AddFiles2Send);
HOOK2(SetFileSendStats);
HOOK2(SendFileSend);
HOOK2(ForwardMsg);
HOOK2(SetCountry);
HOOK2(GetAddUINInfo);
HOOK2(ShareContacts);
HOOK2(SaveErrors);
HOOK2(ChatWinState);
HOOK2(EndAllChat);
HOOK2(SetBIU);
HOOK2(SetLocalFColor);
HOOK2(SetUserVisPrefs);
HOOK2(OpenEditIgnore);
HOOK2(SetIgnoreEdits);
HOOK2(ChangeZodiac);
HOOK2(ResetSockets);

HOOK2(RxStatus);
HOOK2(RxGetContact);
HOOK2(RxSendMessage);
HOOK2(RxWinControl);
HOOK2(RxAddFile);
HOOK2(RxFileDirect);
HOOK2(RxGetVersion);
HOOK2(RxDeleteUIN);
HOOK2(RxGetFiles);
HOOK2(RxAcceptChatFile);

sprintf(splash,"%sImages/Splash",path);
sprintf(about,"%sImages/About",path);
sprintf(zodiac,"%sImages/January",path);

if (!(lock = Lock(splash,SHARED_LOCK))) {
  splash[0] = '\0';
}
else UnLock(lock);

if (!(mcc_Time      = MUI_CreateCustomClass(NULL,MUIC_Notify    ,NULL,sizeof(struct TimeData) ,TimeDispatcher)))  fail(NULL,"Could not create mcc_Time.");
if (!(mcc_Port      = MUI_CreateCustomClass(NULL,MUIC_Notify    ,NULL,sizeof(struct SigData)  ,MyDispatcher)))    fail(NULL,"Could not create mcc_Port.");
if (!(mcc_Color     = MUI_CreateCustomClass(NULL,MUIC_Text      ,NULL,sizeof(struct ColorData),ColorDispatcher))) fail(NULL,"Could not create mcc_Color.");
if (!(mcc_Chat      = MUI_CreateCustomClass(NULL,MUIC_TextEditor,NULL,sizeof(struct ChatData) ,ChatDispatcher)))  fail(NULL,"Could not create mcc_Chat (Missing 'MUI:Libs/mui/TextEditor.mcc'?)");
if (!(mcc_Cols      = MUI_CreateCustomClass(NULL,MUIC_NList     ,NULL,sizeof(struct ColsData) ,ColsDispatcher)))  fail(NULL,"Could not create mcc_Cols (Missing 'MUI:Libs/mui/NList.mcc'?)");


/* Nogfx Add Menus/Strings Localization*/

UpdateStrings();
localize_array(Statii);
localize_array(PagesInfo);
localize_array(PagesOpts);
localize_array(PagesAway);
localize_array(AboutPages);
localize_array(PagesColor);
localize_array(GroupPages);
localize_array(Sex);
localize_array(Months);
localize_array(PicPrivacy);
localize_array(Authorization);

/* End Locale */

ObjectApp->App = ApplicationObject,
  MUIA_Application_Author,      "Douglas F. McLaughlin ",
  MUIA_Application_Base,        "STRICQ",
  MUIA_Application_Title,       "STRICQ",
  MUIA_Application_Version,     "$VER: STRICQ (68020) 0.1732 (20.08.00)",
  MUIA_Application_Copyright,   "Douglas F. McLaughlin",
  MUIA_Application_Description,msgICQClient,  // "An Amiga ICQ Client",
  MUIA_Application_Menustrip,   ObjectApp->NM_AppMenu = MUI_MakeObject(MUIO_MenustripNM,STRICQMenu,0),
  MUIA_Application_Commands,    &STRICQRexx,
  MUIA_Application_DiskObject,  ObjectApp->DO_IconifyIcon = GetDiskObject("PROGDIR:STRICQ"),    // "ENV:SYS/def_STRICQ"),
  SubWindow, ObjectApp->WI_Main = WindowObject,
    MUIA_Window_Title, "STRICQ",
    MUIA_Window_ID, MAKE_ID('I','C','Q','1'),
    WindowContents, GroupObject,
      Child, ObjectApp->TX_Color = NewObject(mcc_Color->mcc_Class, NULL,
        MUIA_Background, MUII_TextBack,
        MUIA_Frame, MUIV_Frame_Text,
        MUIA_Text_PreParse, "\033c",
      End,
      Child, VGroup,
        Child, ObjectApp->LV_OfflineList = NListviewObject,
          MUIA_NListview_NList, NListObject,
            MUIA_Frame, MUIV_Frame_String,
            MUIA_ShortHelp, msgHelp1, //"Double-Click here to open\nthe User Window.",
            MUIA_CycleChain, TRUE,
            MUIA_NList_MultiSelect, MUIV_NList_MultiSelect_Default,
            MUIA_NList_Title, TRUE,
            MUIA_NList_Format, "NOBAR,BAR,BAR,BAR,BAR,BAR,BAR,BAR,BAR,",
            MUIA_NList_CompareHook,   &CmpOfflineHook,
            MUIA_NList_ConstructHook, &AddOfflineHook,
            MUIA_NList_DestructHook,  &RemOfflineHook,
            MUIA_NList_DisplayHook,   &DisplayOfflineHook,
          End,
        End,
      End,
      Child, HGroup,
        MUIA_Group_Columns, 2,
        Child, ObjectApp->BT_AddContact = SimpleButton(msgAdd), //("Add"),
        Child, ObjectApp->BT_RemContact = SimpleButton(msgRemove),  //("Remove"),
      End,
      Child, ObjectApp->CY_MyStatus = CycleObject,
        MUIA_Cycle_Entries, Statii,
        MUIA_ObjectID, OID_STATUS,
        MUIA_Weight, 0,
        MUIA_CycleChain, TRUE,
      End,
    End,
  End,
  SubWindow, ObjectApp->WI_About = WindowObject,
    MUIA_Window_Title, msgAboutWin, //"About STRICQ",
    MUIA_Window_ID, MAKE_ID('A','B','O','T'),
    WindowContents, VGroup,
             
                Child, RegisterGroup(AboutPages),
                    MUIA_Register_Frame, TRUE,

                    Child, VGroup,
                      Child, MUI_NewObject("Dtpic.mui",
                        MUIA_Dtpic_Name, about,
                        MUIA_Frame, MUIV_Frame_Text,
                      End,
                      Child, HSpace(0),

                      Child, TextObject,
                        MUIA_Font, MUIV_Font_Big,
                        MUIA_Text_Contents, "\33c\33bSTRICQ (68020) v0.1732 (20.08.00)",
                      End,
                  

                      Child, TextObject,
                        MUIA_Text_Contents, "\33cCopyright  1998-2000 Douglas F. McLaughlin\n\33cICQ Protocol  1996 Mirabilis LTD.\n\33cAll Rights Reserved.",
                      End,
                      Child, VSpace(4),
                      Child, RectangleObject,
                        MUIA_FixHeight, 8,
                        MUIA_Rectangle_HBar, TRUE,
                      End,
                     
                    End,
               
                    Child, VGroup,
                     Child, NListviewObject,
                       MUIA_NListview_NList, NFloattextObject,
                       ReadListFrame,
                       MUIA_NFloattext_Text, msgAboutAuth,
                     End,
                    End,
                   End,
                
                    Child, VGroup,
                     Child, NListviewObject,
                       MUIA_NListview_NList, NFloattextObject,
                       ReadListFrame,
                       MUIA_NFloattext_Text, msgAboutLicense,
                     End,
                    End,
                   End,

                /*    End,*/
                End,
   
       End,
  End,
  SubWindow, ObjectApp->WI_Splash = WindowObject,
  /*  MUIA_Window_CloseGadget, FALSE,
    MUIA_Window_DepthGadget, FALSE,
    MUIA_Window_DragBar, FALSE,
    MUIA_Window_Activate, FALSE, */
    MUIA_Window_Title,msgWinLoad, //"Load Progress",
    MUIA_Window_ID, MAKE_ID('E','S','S','A'),
    WindowContents, VGroup,
      Child, ObjectApp->DT_Splash = MUI_NewObject("Dtpic.mui",
        MUIA_Frame, MUIV_Frame_ImageButton,
        MUIA_Dtpic_Name, splash,
      End,
      /* Child Jauge Object ADDED HERE */
      Child, ObjectApp->GA_Contacts = GaugeObject,
        MUIA_Background, MUII_TextBack,
        MUIA_Frame, MUIV_Frame_Gauge,
        MUIA_Gauge_Horiz, TRUE,
       /* MUIA_FixWidth,150,
        MUIA_Height, 4,    */
        MUIA_Gauge_InfoText, msgInit,
      End,

      //   Child, ObjectApp->TX_LoadProgress = TextObject,
      //  MUIA_Background, MUII_TextBack,
      //  MUIA_Frame, MUIV_Frame_Text,
      //  MUIA_Text_PreParse, "\33c",
      //  MUIA_Text_Contents,msgInit, //"Initializing",
     // End,

    End,
  End,
  SubWindow, ObjectApp->WI_Progress = WindowObject,
    MUIA_Window_Title,msgWinLoad, //"Load Progress",
    MUIA_Window_ID, MAKE_ID('P','R','O','G'),
    WindowContents, VGroup,
      /* Child Gauge Object */
    
      /* Second Child Removed */
    End,
  End,
  SubWindow, ObjectApp->WI_Log = WindowObject,
    MUIA_Window_Title,msgWinLog, //"STRICQ Log",
    MUIA_Window_ID, MAKE_ID('L','O','G','1'),
    WindowContents, GroupObject,
      Child, VGroup,
        MUIA_Frame, MUIV_Frame_Group,
        MUIA_FrameTitle,msgICQLog1, //"From Client To Server:",
        Child, ObjectApp->LV_ICQCliLog = NListviewObject,
          MUIA_NListview_NList, NListObject,
            MUIA_Frame, MUIV_Frame_String,
            MUIA_NList_Title, TRUE,
            MUIA_NList_Format, "BAR,BAR,BAR,BAR,",
            MUIA_NList_CompareHook,   &CmpLogHook,
            MUIA_NList_ConstructHook, &AddLogHook,
            MUIA_NList_DestructHook,  &RemLogHook,
            MUIA_NList_DisplayHook,   &DisplayLogHook,
          End,
        End,
      End,
      Child, BalanceObject, End,
      Child, VGroup,
        MUIA_Frame, MUIV_Frame_Group,
        MUIA_FrameTitle,msgICQLog2, //"From Server To Client:",
        Child, ObjectApp->LV_ICQSrvLog = NListviewObject,
          MUIA_NListview_NList, NListObject,
            MUIA_Frame, MUIV_Frame_String,
            MUIA_NList_Title, TRUE,
            MUIA_NList_Format, "BAR,BAR,BAR,BAR,",
            MUIA_NList_CompareHook,   &CmpLogHook,
            MUIA_NList_ConstructHook, &AddLogHook,
            MUIA_NList_DestructHook,  &RemLogHook,
            MUIA_NList_DisplayHook,   &DisplayLogHook,
          End,
        End,
      End,
    End,
  End,
  SubWindow, ObjectApp->WI_Message = WindowObject,
    MUIA_Window_Title,msgWinMessages, //"Incoming Messages",
    MUIA_Window_ID, MAKE_ID('M','S','G','S'),
    WindowContents, GroupObject,
      Child, ObjectApp->LV_Msgs = NListviewObject,
        MUIA_NListview_NList, NListObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_CycleChain, 1,
          MUIA_NList_Title, TRUE,
          MUIA_NList_Format, "BAR,BAR,",
          MUIA_NList_CompareHook,   &CmpMsgHook,
          MUIA_NList_ConstructHook, &AddMsgHook,
          MUIA_NList_DestructHook,  &RemMsgHook,
          MUIA_NList_DisplayHook,   &DisplayMsgHook,
        End,
      End,
      Child, HGroup,
        MUIA_Group_Columns, 2,
        Child, ObjectApp->BT_ReplyMessage = KeyButton(msgReply,'r'), //("Reply",'r'),
        Child, ObjectApp->BT_GetInfo = KeyButton(msgGetInfo,'i'),  //("Get Info",'i'),
        Child, ObjectApp->BT_RemMessage = KeyButton(msgRemoveMsg,'m'), //"Remove Message",'m'),
        Child, ObjectApp->BT_ClearMsgs = KeyButton(msgClearMsg,'c'), //"Clear Messages",'c'),
        Child, ObjectApp->BT_Auth = KeyButton(msgAutho,'a'), //"Authorize",'a'),
        Child, ObjectApp->BT_OpenURLWin = KeyButton(msgSendURL,'u'), //"Send URL",'u'),
      End,
      Child, HGroup,
        MUIA_Group_Columns, 2,
        Child, Label(msgMessage), //"Message"),
        Child, ObjectApp->TI_QuickMsg = TextinputObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_CycleChain, 1,
          MUIA_Textinput_Multiline, FALSE,
          MUIA_Textinput_Contents, NULL,
          MUIA_Textinput_MaxLen, 450,
          MUIA_Textinput_RemainActive, TRUE,
        End,
        Child, Label(msgSendTo), //"Send to"),
        Child, ObjectApp->TX_QuickTo = TextObject,
          MUIA_Background, MUII_TextBack,
          MUIA_Frame, MUIV_Frame_Text,
          MUIA_Text_Contents, NULL,
        End,
      End,
    End,
  End,
  SubWindow, ObjectApp->WI_Send = WindowObject,
    MUIA_Window_Title, msgWinSendMsg, //"Send Message",
    MUIA_Window_ID, MAKE_ID('M','E','S','G'),
    WindowContents, GroupObject,
      Child, HGroup,
        Child, ObjectApp->TX_Sendto = TextObject,
          MUIA_Background, MUII_TextBack,
          MUIA_Frame, MUIV_Frame_Text,
          MUIA_Text_Contents, NULL,
          MUIA_Text_PreParse, "\33c",
        End,
      End,
      Child, ObjectApp->TI_Message = TextinputObject,
        MUIA_Frame, MUIV_Frame_String,
        MUIA_CycleChain, 1,
        MUIA_Textinput_Multiline, TRUE,
        MUIA_Textinput_Contents, NULL,
      End,
      Child, ObjectApp->BT_Sendit = KeyButton(msgSendThis,'s'), //"Send This Message",'s'),
    End,
  End,
  SubWindow, ObjectApp->WI_Information = WindowObject,
    MUIA_Window_Title, msgWinUserInfo, //"User Information",
    MUIA_Window_ID, MAKE_ID('I','N','F','O'),
    WindowContents, GroupObject,
      Child, RegisterObject,
        MUIA_Register_Titles, PagesInfo,
        MUIA_CycleChain, TRUE,
        Child, VGroup,
          MUIA_Group_Columns, 2,
          Child, Label("UIN"),
          Child, ObjectApp->STR_UserUIN = TextObject,
            MUIA_Frame, MUIV_Frame_Text,
          End,
          Child, Label(msgNick), //"Nick"),
          Child, ObjectApp->STR_UserNick = TextinputObject,
            MUIA_Frame, MUIV_Frame_String,
            MUIA_CycleChain, 1,
          End,
          Child, Label(msgFirst), //"First"),
          Child, ObjectApp->STR_UserFirst = TextinputObject,
            MUIA_Frame, MUIV_Frame_String,
            MUIA_CycleChain, 1,
          End,
          Child, Label(msgLast), //"Last"),
          Child, ObjectApp->STR_UserLast = TextinputObject,
            MUIA_Frame, MUIV_Frame_String,
            MUIA_CycleChain, 1,
          End,
          Child, Label(msgEMail), //"E-Mail"),
          Child, ObjectApp->STR_UserEMail = TextObject,
            MUIA_Frame, MUIV_Frame_Text,
          End,
          Child, Label(msgAuthReq), //"Auth. Required"),
          Child, ObjectApp->STR_UserAuth = TextObject,
            MUIA_Frame, MUIV_Frame_Text,
          End,
        End,
        Child, VGroup,
          MUIA_Group_Columns, 2,
          Child, Label(msgCity), //"City"),
          Child, ObjectApp->TX_UserCity = TextObject,
            MUIA_Frame, MUIV_Frame_Text,
          End,
          Child, Label(msgCCode), //"Country Code"),
          Child, ObjectApp->TX_UserCountry = TextObject,
            MUIA_Frame, MUIV_Frame_Text,
          End,
          Child, Label(msgTZone), //"Time Zone"),
          Child, ObjectApp->NU_UserZone = SliderObject,
            MUIA_Numeric_Max, 12,
            MUIA_Numeric_Min, -12,
            MUIA_CycleChain, TRUE,
          End,
          Child, Label(msgState), //"State"),
          Child, ObjectApp->TX_UserState = TextObject,
            MUIA_Frame, MUIV_Frame_Text,
          End,
          Child, Label(msgAge), //"Age"),
          Child, ObjectApp->TX_UserAge = TextObject,
            MUIA_Frame, MUIV_Frame_Text,
          End,
          Child, Label(msgSex), //"Sex"),
          Child, ObjectApp->TX_UserSex = TextObject,
            MUIA_Frame, MUIV_Frame_Text,
          End,
          Child, Label(msgPhone), //"Phone"),
          Child, ObjectApp->TX_UserPhone = TextObject,
            MUIA_Frame, MUIV_Frame_Text,
          End,
          Child, Label(msgHomePage), //"Home Page"),
          Child, ObjectApp->TX_UserURL = TextObject,
            MUIA_Frame, MUIV_Frame_Button,
            MUIA_Font, MUIV_Font_Button,
            MUIA_Text_Contents, NULL,
            MUIA_Text_PreParse, "\33c",
            MUIA_InputMode, MUIV_InputMode_RelVerify,
            MUIA_Background, MUII_ButtonBack,
          End,
          Child, VGroup,
            Child, HVSpace,
            Child, Label(msgLabelAbout), //"About"),
            Child, HVSpace,
          End,
          Child, ObjectApp->LV_UserAbout = NListviewObject,
            MUIA_NListview_NList, NListObject,
              MUIA_Frame, MUIV_Frame_String,
              MUIA_NList_ConstructHook, MUIV_NList_ConstructHook_String,
              MUIA_NList_DestructHook, MUIV_NList_DestructHook_String,
            End,
          End,
        End,
      End,
      Child, ObjectApp->BT_AddUpdate = SimpleButton(msgAddContact), //"Add To Contact List"),
    End,
  End,
  SubWindow, ObjectApp->WI_Searches = WindowObject,
    MUIA_Window_Title, msgWinAddUIN, //"Search For User",
    MUIA_Window_ID, MAKE_ID('S','R','C','H'),
    WindowContents, VGroup,
      Child, HGroup,
        MUIA_Frame, MUIV_Frame_Group,
        MUIA_Group_Columns, 4,
        Child, Label(msgSearchUIN), //"Search UIN"),
        Child, ObjectApp->CH_SearchUIN = CheckMark(TRUE),
        Child, Label("UIN"),
        Child, ObjectApp->STR_SrchUIN = TextinputObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_Textinput_AcceptChars, "0123456789",
          MUIA_String_AdvanceOnCR, TRUE,
          MUIA_CycleChain, TRUE,
        End,
        Child, Label(msgSearchEM), //"Search E-Mail"),
        Child, ObjectApp->CH_SearchEMail = CheckMark(FALSE),
        Child, Label(msgEMail), //"E-Mail"),
        Child, ObjectApp->STR_SrchEMail = TextinputObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_Disabled, TRUE,
          MUIA_String_AdvanceOnCR, TRUE,
          MUIA_CycleChain, TRUE,
        End,
        Child, HVSpace,
        Child, HVSpace,
        Child, Label(msgNick), //"Nick"),
        Child, ObjectApp->STR_SrchNick = TextinputObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_Disabled, TRUE,
          MUIA_CycleChain, 1,
          MUIA_String_AdvanceOnCR, TRUE,
        End,
        Child, Label(msgSearchName), //"Search Name"),
        Child, ObjectApp->CH_SearchName = CheckMark(FALSE),
        Child, Label(msgFirst), //"First"),
        Child, ObjectApp->STR_SrchFirst = TextinputObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_Disabled, TRUE,
          MUIA_CycleChain, 1,
          MUIA_String_AdvanceOnCR, TRUE,
        End,
        Child, HVSpace,
        Child, HVSpace,
        Child, Label(msgLast), //"Last"),
        Child, ObjectApp->STR_SrchLast = TextinputObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_Disabled, TRUE,
          MUIA_CycleChain, 1,
          MUIA_String_AdvanceOnCR, TRUE,
        End,
      End,
      Child, ObjectApp->BT_StartSrch = SimpleButton(msgStartSea), //"Start Search"),
    End,
  End,
  SubWindow, ObjectApp->WI_SrchResults = WindowObject,
    MUIA_Window_Title, msgWinSeaResults, //"Search Results",
    MUIA_Window_ID, MAKE_ID('R','S','L','T'),
    WindowContents, VGroup,
      Child, VGroup,
        MUIA_Frame, MUIV_Frame_Group,
        MUIA_FrameTitle, msgSeaHits, //"Search Hits:",
        Child, ObjectApp->LV_SearchList = NListviewObject,
          MUIA_NListview_NList, NListObject,
            MUIA_Frame, MUIV_Frame_String,
            MUIA_CycleChain, TRUE,
            MUIA_NList_Title, TRUE,
            MUIA_NList_Format, "COL=1 BAR,COL=3 BAR,COL=4 BAR,COL=5 BAR,COL=6",
            MUIA_NList_CompareHook,   &CmpOfflineHook,
            MUIA_NList_ConstructHook, &AddOfflineHook,
            MUIA_NList_DestructHook,  &RemOfflineHook,
            MUIA_NList_DisplayHook,   &DisplayOfflineHook,
          End,
        End,
      End,
      Child, ObjectApp->TX_SearchStat = TextObject,
        MUIA_Frame, MUIV_Frame_Text,
        MUIA_Text_Contents, NULL,
        MUIA_Text_PreParse, "\33c",
      End,
      Child, HGroup,
        Child, ObjectApp->BT_AddUpdate2 = SimpleButton(msgAddUpdate2), //"Add / Update Contact List"),
        Child, ObjectApp->BT_GetInfo3 = SimpleButton(msgGetUsrInfo), //"Get Userinfo"),
      End,
    End,
  End,
  SubWindow, ObjectApp->WI_SendURL = WindowObject,
    MUIA_Window_Title, msgWinSendURL, //"Send a URL",
    MUIA_Window_ID, MAKE_ID('U','R','L','1'),
    WindowContents, VGroup,
      Child, ObjectApp->TX_SendURLto = TextObject,
        MUIA_Background, MUII_TextBack,
        MUIA_Frame, MUIV_Frame_Text,
        MUIA_Text_Contents, NULL,
        MUIA_Text_PreParse, "\33c",
      End,
      Child, VGroup,
        MUIA_Group_Columns, 2,
        Child, Label(msgDesc), //"Description"),
        Child, ObjectApp->STR_Desc = TextinputObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_Textinput_Multiline, FALSE,
          MUIA_Textinput_Contents, NULL,
          MUIA_CycleChain, 1,
        End,
        Child, Label(msgURL), //"URL"),
        Child, ObjectApp->STR_URL = TextinputObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_Textinput_Multiline, FALSE,
          MUIA_Textinput_Contents, NULL,
          MUIA_CycleChain, 1,
        End,
      End,
      Child, ObjectApp->BT_URLSend = SimpleButton(msgBTURLSend), //"Send This URL"),
    End,
  End,
  SubWindow, ObjectApp->WI_URLMessage = WindowObject,
    MUIA_Window_Title, msgWinSysMsg, //"System Message",
    MUIA_Window_ID, MAKE_ID('U','R','L','M'),
    WindowContents, VGroup,
      Child, ObjectApp->LV_AdText = NListviewObject,
        MUIA_NListview_NList, NListObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_NList_ConstructHook, MUIV_NList_ConstructHook_String,
          MUIA_NList_DestructHook, MUIV_NList_DestructHook_String,
        End,
      End,
      Child, ObjectApp->TX_AdURL = TextObject,
        MUIA_Background, MUII_TextBack,
        MUIA_Frame, MUIV_Frame_Text,
        MUIA_ShowMe, FALSE,
      End,
      Child, ObjectApp->BT_AdGoURL = TextObject,
        MUIA_Frame, MUIV_Frame_Button,
        MUIA_Font, MUIV_Font_Button,
        MUIA_Text_Contents, NULL,
        MUIA_Text_PreParse, "\33c",
        MUIA_InputMode, MUIV_InputMode_RelVerify,
        MUIA_Background, MUII_ButtonBack,
        MUIA_CycleChain, TRUE,
      End,
      Child, HGroup,
        Child, HVSpace,
        Child, ObjectApp->BT_AdOK = SimpleButton(msgOK), //"OK"),
        Child, HVSpace,
      End,
    End,
  End,
  SubWindow, ObjectApp->WI_MessageHist = WindowObject,
    MUIA_Window_Title, msgWinTitleMsgHist, //"Message History",
    MUIA_Window_ID, MAKE_ID('H','I','S','T'),
    WindowContents, VGroup,
      Child, ObjectApp->TX_MsgUser = TextObject,
        MUIA_Background, MUII_TextBack,
        MUIA_Frame, MUIV_Frame_Text,
        MUIA_Text_Contents, NULL,
        MUIA_Text_PreParse, "\033c",
      End,
      Child, HGroup,
        Child, ObjectApp->DL_MsgDir = ListviewObject,
          MUIA_Listview_Input, TRUE,
          MUIA_Weight, 30,
          MUIA_Listview_List, DirlistObject,
            MUIA_Frame, MUIV_Frame_String,
            MUIA_CycleChain, TRUE,
            MUIA_List_Format, "COL=0, COL=5",
            MUIA_Dirlist_FilesOnly, TRUE,
          End,
        End,
        Child, BalanceObject, End,
        Child, ObjectApp->LV_MsgText = NListviewObject,
          MUIA_NListview_NList, NListObject,
            MUIA_Frame, MUIV_Frame_String,
            MUIA_CycleChain, TRUE,
            MUIA_NList_TypeSelect, MUIV_NList_TypeSelect_Char,
            MUIA_NList_ConstructHook, MUIV_NList_ConstructHook_String,
            MUIA_NList_DestructHook, MUIV_NList_DestructHook_String,
          End,
        End,
      End,
    End,
  End,
  SubWindow, ObjectApp->WI_Activities = WindowObject,
    MUIA_Window_Title, msgWinActLog, //"Activity Log",
    MUIA_Window_ID, MAKE_ID('A','C','T','Y'),
    WindowContents, VGroup,
      Child, ObjectApp->LV_Activity = NListviewObject,
        MUIA_NListview_NList, NListObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_NList_Title, TRUE,
          MUIA_NList_Format, "BAR,BAR,",
          MUIA_NList_CompareHook,   &CmpActyHook,
          MUIA_NList_ConstructHook, &AddActyHook,
          MUIA_NList_DestructHook,  &RemActyHook,
          MUIA_NList_DisplayHook,   &DisplayActyHook,
        End,
      End,
    End,
  End,
  SubWindow, ObjectApp->WI_Sockets = WindowObject,
    MUIA_Window_Title, msgWinActSock, //"Active Sockets",
    MUIA_Window_ID, MAKE_ID('S','O','C','K'),
    WindowContents, VGroup,
      Child, ObjectApp->LV_SockList = NListviewObject,
        MUIA_NListview_NList, NListObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_NList_Title, TRUE,
          MUIA_NList_Format, "BAR,BAR,BAR,BAR,",  //Socket, Nick, Dir, IP:Port, Type
          MUIA_NList_CompareHook,   &CmpSockHook,
          MUIA_NList_ConstructHook, &AddSockHook,
          MUIA_NList_DestructHook,  &RemSockHook,
          MUIA_NList_DisplayHook,   &DisplaySockHook,
        End,
      End,
    End,
  End,
  SubWindow, ObjectApp->WI_ChatReqOut = WindowObject,
    MUIA_Window_Title, msgWinChatReq, //"Chat Request",
    MUIA_Window_ID, MAKE_ID('C','H','A','T'),
    WindowContents, VGroup,
      Child, VGroup,
        Child, ObjectApp->LV_Sessions = NListviewObject,
          MUIA_NListview_NList, NListObject,
            MUIA_Frame, MUIV_Frame_String,
            MUIA_CycleChain, TRUE,
            MUIA_NList_Title, TRUE,
            MUIA_NList_Format, "BAR,",  //Port, Nicks
            MUIA_NList_CompareHook,   &CmpSessionHook,
            MUIA_NList_ConstructHook, &AddSessionHook,
            MUIA_NList_DestructHook,  &RemSessionHook,
            MUIA_NList_DisplayHook,   &DisplaySessionHook,
          End,
        End,
        Child, ObjectApp->TI_ChatReason = TextinputObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_CycleChain, TRUE,
          MUIA_Textinput_Contents, NULL,
          MUIA_Textinput_MaxLen, 512,
        End,
      End,
      Child, HGroup,
        Child, ObjectApp->BT_SendChat = SimpleButton(msgButSChat), //"Chat"),
        Child, ObjectApp->BT_JoinChat = SimpleButton(msgButJChat), //"Join"),
        Child, HVSpace,
        Child, ObjectApp->BT_CancelChat = SimpleButton(msgCancel), //"Cancel"),
      End,
    End,
  End,
  SubWindow, ObjectApp->WI_FileSendOut = WindowObject,
    MUIA_Window_Title, msgWinFileDReq, //"FileDirect Request",
    MUIA_Window_ID, MAKE_ID('F','I','L','E'),
    WindowContents, GroupObject,
      Child, GroupObject,
        MUIA_Frame, MUIV_Frame_Group,
        MUIA_FrameTitle, msgFileList, //"File List",
        Child, ObjectApp->LV_FileList = NListviewObject,
          MUIA_CycleChain, 1,
          MUIA_NListview_NList, NListObject,
            MUIA_Frame, MUIV_Frame_String,
            MUIA_CycleChain, TRUE,
            MUIA_NList_Title, TRUE,
            MUIA_NList_Format, "BAR,",  // Filename, Filesize
            MUIA_NList_CompareHook,   &CmpFileHook,
            MUIA_NList_ConstructHook, &AddFileHook,
            MUIA_NList_DestructHook,  &RemFileHook,
            MUIA_NList_DisplayHook,   &DisplayFileHook,
          End,
        End,
        Child, HGroup,
            Child, ObjectApp->TX_TotalFiles = TextObject,
            MUIA_Background, MUII_TextBack,
            MUIA_Frame, MUIV_Frame_Text,
            MUIA_Text_Contents, NULL,
            MUIA_Text_PreParse, "\033c",
          End,
            Child, ObjectApp->TX_TotalSize = TextObject,
            MUIA_Background, MUII_TextBack,
            MUIA_Frame, MUIV_Frame_Text,
            MUIA_Text_Contents, NULL,
            MUIA_Text_PreParse, "\033c",
          End,
        End,
        Child, HGroup,
          Child, ObjectApp->BT_AddFile = KeyButton(msgButAddFile,'a'), //"Add File(s)",'a'),
          Child, ObjectApp->BT_RemFile = KeyButton(msgButRemoveFile,'d'), //"Remove File",'d'),
        End,
      End,
      Child, ObjectApp->GP_FDescGroup = GroupObject,
        MUIA_Frame, MUIV_Frame_Group,
        MUIA_FrameTitle, msgFrameFileDes, //"Enter File Description",
        Child, ObjectApp->TI_FileReason = TextinputObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_Textinput_Contents, NULL,
          MUIA_Textinput_MaxLen, 512,
          MUIA_CycleChain, 1,
        End,
        Child, HGroup,
          Child, ObjectApp->BT_SendFile = KeyButton(msgSend,'s'), //"Send",'s'),
          Child, ObjectApp->BT_CancelFile = KeyButton(msgCancel,'c'), //"Cancel",'c'),
        End,
      End,
    End,
  End,
  SubWindow, ObjectApp->WI_AddUIN = WindowObject,
    MUIA_Window_Title, msgWinAddUINReq, //"Add UIN Request",
    MUIA_Window_ID, MAKE_ID('A','D','U','N'),
    WindowContents, VGroup,
      Child, ObjectApp->TX_Desc = TextObject,
        MUIA_Background, MUII_TextBack,
        MUIA_Frame, MUIV_Frame_Text,
        MUIA_Text_Contents, NULL,
        MUIA_Text_PreParse, "\033c",
      End,
      Child, ObjectApp->LV_ToAddUIN = NListviewObject,
        MUIA_CycleChain, 1,
        MUIA_NListview_NList, NListObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_CycleChain, TRUE,
          MUIA_NList_Title, TRUE,
          MUIA_NList_Format, "BAR,BAR,",  // UIN, Nick, Already
          MUIA_NList_CompareHook,   &CmpAddUINHook,
          MUIA_NList_ConstructHook, &AddAddUINHook,
          MUIA_NList_DestructHook,  &RemAddUINHook,
          MUIA_NList_DisplayHook,   &DisplayAddUINHook,
        End,
      End,
      Child, HGroup,
        Child, ObjectApp->BT_AddUIN = SimpleButton(msgButAddUIN), //"Get Userinfo"),
        Child, HVSpace,
        Child, ObjectApp->BT_AddCancel = SimpleButton(msgClose), //"Close"),
      End,
    End,
  End,
  SubWindow, ObjectApp->WI_WebPager = WindowObject,
    MUIA_Window_Title, msgWinPagerMsg, //"Pager Messages",
    MUIA_Window_ID, MAKE_ID('P','A','G','E'),
    WindowContents, VGroup,
      MUIA_Group_Columns, 2,
      Child, Label(msgName), //"Name"),
      Child, ObjectApp->TX_WebName = TextObject,
        MUIA_Background, MUII_TextBack,
        MUIA_Frame, MUIV_Frame_Text,
        MUIA_Text_Contents, NULL,
      End,
      Child, Label(msgEMail), //"EMail"),
      Child, ObjectApp->TX_WebEMail = TextObject,
        MUIA_Background, MUII_TextBack,
        MUIA_Frame, MUIV_Frame_Text,
        MUIA_Text_Contents, NULL,
      End,
      Child, VGroup,
        Child, VSpace(0),
        Child, Label(msgMessage), //"Message"),
        Child, VSpace(0),
      End,
      Child, ObjectApp->LV_WebMsg = NListviewObject,
        MUIA_NListview_NList, NListObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_NList_ConstructHook, MUIV_NList_ConstructHook_String,
          MUIA_NList_DestructHook,  MUIV_NList_DestructHook_String,
        End,
      End,
    End,
  End,
  SubWindow, ObjectApp->WI_ErrorWin = WindowObject,
    MUIA_Window_Title, msgWinErrorsDebug, //"Errors, Information & Debug",
    MUIA_Window_ID, MAKE_ID('E','R','R','S'),
    WindowContents, VGroup,
      Child, HGroup,
        MUIA_Frame, MUIV_Frame_Group,
        MUIA_FrameTitle, msgDebugLev, //"Debug Levels",
        MUIA_Group_Columns, 6,
        Child, HSpace(0),
        Child, Label(msgShowUDPPack), //"Show UDP Packets"),
        Child, ObjectApp->CH_UDPPkts = ImageObject,
          MUIA_Frame, MUIV_Frame_ImageButton,
          MUIA_InputMode, MUIV_InputMode_Toggle,
          MUIA_Image_Spec, MUII_CheckMark,
          MUIA_Image_FreeVert, TRUE,
          MUIA_Selected, FALSE,
          MUIA_Background, MUII_ButtonBack,
          MUIA_ShowSelState, FALSE,
          MUIA_ObjectID, OID_UDPPKTS,
          MUIA_CycleChain, 1,
        End,
        Child, ObjectApp->CH_UDPDebug = ImageObject,
          MUIA_Frame, MUIV_Frame_ImageButton,
          MUIA_InputMode, MUIV_InputMode_Toggle,
          MUIA_Image_Spec, MUII_CheckMark,
          MUIA_Image_FreeVert, TRUE,
          MUIA_Selected, TRUE,
          MUIA_Background, MUII_ButtonBack,
          MUIA_ShowSelState, FALSE,
          MUIA_ObjectID, OID_UDPDEBUG,
          MUIA_CycleChain, 1,
        End,
        Child, LLabel(msgShowUDPDebug), //"Show UDP Debug"),
        Child, HSpace(0),
        Child, HSpace(0),
        Child, Label(msgShowTCPSock), //"Show TCP Packets"),
        Child, ObjectApp->CH_TCPPkts = ImageObject,
          MUIA_Frame, MUIV_Frame_ImageButton,
          MUIA_InputMode, MUIV_InputMode_Toggle,
          MUIA_Image_Spec, MUII_CheckMark,
          MUIA_Image_FreeVert, TRUE,
          MUIA_Selected, FALSE,
          MUIA_Background, MUII_ButtonBack,
          MUIA_ShowSelState, FALSE,
          MUIA_ObjectID, OID_TCPPKTS,
          MUIA_CycleChain, 1,
        End,
        Child, ObjectApp->CH_TCPDebug = ImageObject,
          MUIA_Frame, MUIV_Frame_ImageButton,
          MUIA_InputMode, MUIV_InputMode_Toggle,
          MUIA_Image_Spec, MUII_CheckMark,
          MUIA_Image_FreeVert, TRUE,
          MUIA_Selected, TRUE,
          MUIA_Background, MUII_ButtonBack,
          MUIA_ShowSelState, FALSE,
          MUIA_ObjectID, OID_TCPDEBUG,
          MUIA_CycleChain, 1,
        End,
        Child, LLabel(msgShowTCPDebug), //"Show TCP Debug"),
        Child, HSpace(0),
      End,
      Child, ObjectApp->LV_Errors = NListviewObject,
        MUIA_CycleChain, TRUE,
        MUIA_NListview_NList, NListObject,
          MUIA_Frame, MUIV_Frame_String,
          MUIA_Font, MUIV_NList_Font_Fixed,
          MUIA_NList_Title, TRUE,
          MUIA_NList_Format, "BAR,",  // Timehack, Error
          MUIA_NList_CompareHook,   &CmpErrHook,
          MUIA_NList_ConstructHook, &AddErrHook,
          MUIA_NList_DestructHook,  &RemErrHook,
          MUIA_NList_DisplayHook,   &DisplayErrHook,
        End,
      End,
      Child, HGroup,
        Child, ObjectApp->BT_ErrClr = SimpleButton(msgButErrClr), //"Clear Errors"),
        Child, ObjectApp->BT_ErrSave = SimpleButton(msgButErrSave), //"Save To File"),
      End,
    End,
  End,
  SubWindow, ObjectApp->WI_EditIgnore = WindowObject,
    MUIA_Window_Title, msgWinIgnoreUIN, //"Ignored UIN",
    MUIA_Window_ID, MAKE_ID('I','G','N','R'),
    WindowContents, VGroup,
      Child, HGroup,
        Child, ObjectApp->TX_IgnoreUIN = TextObject,
          MUIA_Background, MUII_TextBack,
          MUIA_Frame, MUIV_Frame_Text,
          MUIA_Text_Contents, NULL,
          MUIA_Text_PreParse, "\033c",
        End,
        Child, ObjectApp->TX_IgnoreNick = TextObject,
          MUIA_Background, MUII_TextBack,
          MUIA_Frame, MUIV_Frame_Text,
          MUIA_Text_Contents, NULL,
          MUIA_Text_PreParse, "\033c",
        End,
      End,
      Child, ObjectApp->NU_IgnoreDays = SliderObject,
        MUIA_Numeric_Max, 365,
        MUIA_Numeric_Min, -1,
        MUIA_Numeric_Value, 30,
        MUIA_CycleChain, 1,
        MUIA_ShortHelp, msgHelpNeverExpire, //"-1 = Never Expire",
      End,
      Child, HGroup,
        Child, ObjectApp->BT_IgnoreOK = SimpleButton(msgOK), //"OK"),
        Child, HSpace(0),
        Child, ObjectApp->BT_IgnoreCanx = SimpleButton(msgCancel), //"Cancel"),
      End,
    End,
  End,
  SubWindow, ObjectApp->WI_ICQPrefs = WindowObject,
    MUIA_Window_Title, msgWinICQPrefs, //"ICQ Preferences",
    MUIA_Window_ID, MAKE_ID('U','S','P','R'),
    WindowContents, VGroup,
      Child, HGroup,
        Child, ObjectApp->LV_InfoPages = NListviewObject,
          MUIA_CycleChain, TRUE,
          MUIA_NListview_NList, NListObject,
            MUIA_Frame, MUIV_Frame_String,
            MUIA_NList_ConstructHook, MUIV_NList_ConstructHook_String,
            MUIA_NList_DestructHook, MUIV_NList_DestructHook_String,
            MUIA_NList_AdjustWidth, TRUE,
            MUIA_NList_SourceArray, GroupPages,
          End,
        End,
        Child, ObjectApp->GP_InfoPages = GroupObject,
          MUIA_Group_PageMode, TRUE,
          MUIA_Frame, MUIV_Frame_Group,
          Child, VGroup,
          Child, VSpace(0),
            Child, HGroup,
              MUIA_Frame, MUIV_Frame_Group,
              MUIA_FrameTitle, msgICQNumber, //"ICQ Number",
              Child, Label(msgICQLabel), //"ICQ#"),
              Child, HGroup,
                Child, ObjectApp->POP_SelectUIN = PopobjectObject,
                  MUIA_Popstring_String, ObjectApp->STR_ICQUIN = StringObject,
                    MUIA_Frame, MUIV_Frame_String,
                    MUIA_ObjectID, OID_UIN,
                    MUIA_String_MaxLen, 33,
                    MUIA_String_Accept, "0123456789",
                    MUIA_CycleChain, TRUE,
                  End,
                  MUIA_Popstring_Button, PopButton(MUII_PopUp),
                  MUIA_CycleChain, TRUE,
                  MUIA_Popobject_ObjStrHook, &ChangeMyUINHook,
                  MUIA_Popobject_Object, GroupObject,
                    Child, ObjectApp->DL_UINList = ListviewObject,
                      MUIA_Listview_Input, TRUE,
                      MUIA_CycleChain, TRUE,
                      MUIA_Listview_List, DirlistObject,
                        MUIA_Frame, MUIV_Frame_InputList, // MUIV_Frame_String
                        MUIA_List_Format, "COL=0, COL=5",
                        MUIA_Dirlist_DrawersOnly, TRUE,
                        MUIA_CycleChain, TRUE,
                      End,
                    End,
                  End,
                End,
              End,
              Child, Label(msgCurrentLastIP), //"Current / Last IP"),
              Child, ObjectApp->TX_CurrentIP = TextObject,
                MUIA_Background, MUII_TextBack,
                MUIA_Font, MUIV_Font_Fixed, // Added 27.07.00
                MUIA_Frame, MUIV_Frame_Text,
                MUIA_Text_Contents, NULL,
                MUIA_Text_PreParse, "\033c",
              End,
            End,
            Child, HGroup,
              MUIA_Frame, MUIV_Frame_Group,
              MUIA_FrameTitle, msgName, //"Name",
              MUIA_Group_Columns, 4,
              Child, Label(msgFirst), //"First"),
              Child, ObjectApp->STR_First = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_MaxLen, 21,
                MUIA_ObjectID, OID_FIRST,
                MUIA_CycleChain, TRUE,
              End,
              Child, Label(msgLast), //"Last"),
              Child, ObjectApp->STR_Last = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_MaxLen, 21,
                MUIA_ObjectID, OID_LAST,
                MUIA_CycleChain, TRUE,
              End,
              Child, Label(msgNickName), //"Nickname"),
              Child, ObjectApp->STR_Nick = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_MaxLen, 21,
                MUIA_ObjectID, OID_NICK,
                MUIA_CycleChain, TRUE,
              End,
              Child, HSpace(0),
              Child, HSpace(0),
            End,
            Child, VSpace(0),
            Child, HGroup,
              MUIA_Frame, MUIV_Frame_Group,
              MUIA_FrameTitle, msgEMailAddr, //"EMail Addresses",
              MUIA_Group_Columns, 2,
              Child, Label(msgPrimaEMail), //"Primary EMail"),
              Child, ObjectApp->STR_EMail = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_MaxLen, 61,
                MUIA_ObjectID, OID_EMAIL,
                MUIA_CycleChain, TRUE,
              End,
              Child, HGroup,
                Child, HSpace(0),
                Child, ObjectApp->CH_HideEMail = ImageObject,
                  MUIA_Frame, MUIV_Frame_ImageButton,
                  MUIA_InputMode, MUIV_InputMode_Toggle,
                  MUIA_Image_Spec, MUII_CheckMark,
                  MUIA_Image_FreeVert, TRUE,
                  MUIA_Selected, FALSE,
                  MUIA_Background, MUII_ButtonBack,
                  MUIA_ShowSelState, FALSE,
                  MUIA_ObjectID, OID_HIDEEMAIL,
                  MUIA_CycleChain, TRUE,
                End,
              End,
              Child, LLabel(msgDontPublish), //"Don't publish my Primary EMail address"),
              Child, Label(msgSecondMail), //Secondary EMail"),
              Child, ObjectApp->STR_EMail2 = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_MaxLen, 61,
                MUIA_ObjectID, OID_EMAIL2,
                MUIA_CycleChain, TRUE,
              End,
              Child, Label(msgOldMail), //"Old EMail"),
              Child, ObjectApp->STR_EMailOld = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_MaxLen, 61,
                MUIA_ObjectID, OID_EMAILOLD,
                MUIA_CycleChain, TRUE,
              End,
            End,
            Child, VSpace(0),
          End,
          Child, VGroup,
            Child, VSpace(0),
            Child, HGroup,
              MUIA_Frame, MUIV_Frame_Group,
              MUIA_FrameTitle, msgHomeAdd, //"Home Address",
              MUIA_Group_Columns, 3,
              Child, VGroup,
                Child, CLabel(msgStreet), //"Street"),
                Child, Label(msgAddress), //"Address"),
              End,
              Child, ObjectApp->TI_StreetAd = TextinputObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_Textinput_Multiline, TRUE,
                MUIA_Textinput_Contents, NULL,
                MUIA_Textinput_MaxLen, 51,
                MUIA_ObjectID, OID_STREETAD,
                MUIA_CycleChain, TRUE,
              End,
              Child, VGroup,
                MUIA_Group_Columns, 2,
                Child, Label(msgCity), //"City"),
                Child, ObjectApp->STR_City = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_MaxLen, 51,
                  MUIA_ObjectID, OID_CITY,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgState), //"State"),
                Child, ObjectApp->STR_State = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_MaxLen, 4,
                  MUIA_ObjectID, OID_STATE,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgZipCode), //"Zip Code"),
                Child, ObjectApp->STR_ZipCode = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_MaxLen, 7,
                  MUIA_ObjectID, OID_ZIPCODE,
                  MUIA_CycleChain, TRUE,
                End,
              End,
              Child, HSpace(0),
              Child, ObjectApp->BT_DisplayMap = SimpleButton(msgButDisp), //"Display Map"),
              Child, HGroup,
                Child, Label(msgCountry), //"Country"),
                Child, ObjectApp->POP_Country = PopobjectObject,
                  MUIA_Popstring_String, ObjectApp->STR_Country = StringObject,
                    MUIA_Frame, MUIV_Frame_String,
                    MUIA_ObjectID, OID_COUNTRY,
                    MUIA_CycleChain, TRUE,
                  End,
                  MUIA_Popstring_Button, PopButton(MUII_PopUp),
                  MUIA_CycleChain, TRUE,
                  MUIA_Popobject_ObjStrHook, &SetCountryHook,
                  MUIA_Popobject_Object, GroupObject,
                    Child, ObjectApp->LV_Countries = NListviewObject,
                      MUIA_CycleChain, TRUE,
                      MUIA_NListview_NList, NListObject,
                        MUIA_Frame, MUIV_Frame_InputList,
                        MUIA_NList_ConstructHook, MUIV_NList_ConstructHook_String,
                        MUIA_NList_DestructHook, MUIV_NList_DestructHook_String,
                        MUIA_NList_SourceArray, CountryNames,
                        MUIA_CycleChain, TRUE,
                      End,
                    End,
                  End,
                End,
              End,
            End,
            Child, VSpace(0),
            Child, HGroup,
              Child, VGroup,
                MUIA_Frame, MUIV_Frame_Group,
                MUIA_FrameTitle, msgPhoneDir, //"Phone Directory Listings",
                MUIA_Group_Columns, 2,
                Child, Label(msgPhone), //"Phone"),
                Child, ObjectApp->STR_Phone = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_MaxLen, 31,
                  MUIA_ObjectID, OID_PHONE,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgFAX), //"FAX"),
                Child, ObjectApp->STR_FAX = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_MaxLen, 31,
                  MUIA_ObjectID, OID_FAX,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgCellular), //"Cellular"),
                Child, ObjectApp->STR_Cellular = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_MaxLen, 31,
                  MUIA_ObjectID, OID_CELLULAR,
                  MUIA_CycleChain, TRUE,
                End,
              End,
              Child, VGroup,
                MUIA_Frame, MUIV_Frame_Group,
                MUIA_FrameTitle, msgLocalTime, //"Local Time",
                MUIA_Group_Columns, 2,
                Child, Label(msgTimeZone), //"Time Zone"),
                Child, ObjectApp->NU_TimeZone = SliderObject,
                  MUIA_Numeric_Max, 12,
                  MUIA_Numeric_Min, -12,
                  MUIA_ObjectID, OID_TIMEZONE,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgLocalTime), //"Local Time"),
                Child, ObjectApp->TX_LocalTime = TextObject,
                  MUIA_Background, MUII_TextBack,
                  MUIA_Frame, MUIV_Frame_Text,
                  MUIA_Text_Contents, NULL,
                  MUIA_Text_PreParse, "\033c",
                End,
              End,
            End,
            Child, VSpace(0),
          End,
          Child, VGroup,
            Child, VSpace(0),
            Child, HGroup,
              Child, VGroup,
                MUIA_Frame, MUIV_Frame_Group,
                MUIA_FrameTitle, msgCompany, //"Company",
                MUIA_Group_Columns, 2,
                Child, Label(msgName), //"Name"),
                Child, ObjectApp->STR_CoName = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_MaxLen, 31,
                  MUIA_ObjectID, OID_CONAME,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgDivDept), //"Div/Dept"),
                Child, ObjectApp->STR_DivDept = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_MaxLen, 41,
                  MUIA_ObjectID, OID_DIVDEPT,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgPosition), //"Position"),
                Child, ObjectApp->STR_Position = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_MaxLen, 41,
                  MUIA_ObjectID, OID_POSITION,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgOccup), //"Occupation"),
                Child, ObjectApp->CY_Occupation = CycleObject,
                  MUIA_Cycle_Entries, Occupations,
                  MUIA_ObjectID, OID_OCCUPATION,
                  MUIA_CycleChain, TRUE,
                End,
              End,
              Child, VGroup,
                MUIA_Frame, MUIV_Frame_Group,
                MUIA_FrameTitle, msgPhoneDir, //"Phone Directory Listings",
                MUIA_Group_Columns, 2,
                Child, Label(msgPhone), //"Phone"),
                Child, ObjectApp->STR_WkPhone = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_MaxLen, 31,
                  MUIA_ObjectID, OID_WKPHONE,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgFAX), //"FAX"),
                Child, ObjectApp->STR_WkFAX = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_MaxLen, 31,
                  MUIA_ObjectID, OID_WKFAX,
                  MUIA_CycleChain, TRUE,
                End,
              End,
            End,
            Child, VSpace(0),
            Child, HGroup,
              MUIA_Frame, MUIV_Frame_Group,
              MUIA_FrameTitle, msgWorkAdd, //"Work Address",
              MUIA_Group_Columns, 3,
              Child, VGroup,
                Child, CLabel(msgStreet), //"Street"),
                Child, Label(msgAddress), //"Address"),
              End,
              Child, ObjectApp->TI_WorkAd = TextinputObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_Textinput_Multiline, TRUE,
                MUIA_Textinput_Contents, NULL,
                MUIA_Textinput_MaxLen, 51,
                MUIA_ObjectID, OID_WORKAD,
                MUIA_CycleChain, TRUE,
              End,
              Child, VGroup,
                MUIA_Group_Columns, 2,
                Child, Label(msgCity), //"City"),
                Child, ObjectApp->STR_WkCity = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_MaxLen, 51,
                  MUIA_ObjectID, OID_WKCITY,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgState), //"State"),
                Child, ObjectApp->STR_WkState = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_MaxLen, 4,
                  MUIA_ObjectID, OID_WKSTATE,
                  MUIA_CycleChain, TRUE,
                End,
              End,
              Child, HSpace(0),
              Child, ObjectApp->BT_DisplayWkMap = SimpleButton(msgButDisp), //"Display Map"),
              Child, HGroup,
                Child, Label(msgZipCode), //"Zip Code"),
                Child, ObjectApp->STR_WkZipCode = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_MaxLen, 6,
                  MUIA_ObjectID, OID_WKZIPCODE,
                  MUIA_CycleChain, TRUE,
                End,
              End,
              Child, Label(msgHomePage), //"Home Page"),
              Child, ObjectApp->STR_WkURL = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_MaxLen, 101,
                MUIA_ObjectID, OID_WKURL,
                MUIA_CycleChain, TRUE,
              End,
              Child, HGroup,
                Child, Label(msgCountry), //"Country"),
                Child, ObjectApp->POP_WkCountry = PopobjectObject,
                  MUIA_Popstring_String, ObjectApp->STR_WkCountry = StringObject,
                    MUIA_Frame, MUIV_Frame_String,
                    MUIA_ObjectID, OID_WKCOUNTRY,
                    MUIA_CycleChain, TRUE,
                  End,
                  MUIA_Popstring_Button, PopButton(MUII_PopUp),
                  MUIA_CycleChain, TRUE,
                  MUIA_Popobject_ObjStrHook, &SetCountryHook,
                  MUIA_Popobject_Object, GroupObject,
                    Child, ObjectApp->LV_WkCountries = NListviewObject,
                      MUIA_CycleChain, TRUE,
                      MUIA_NListview_NList, NListObject,
                        MUIA_Frame, MUIV_Frame_InputList,
                        MUIA_NList_ConstructHook, MUIV_NList_ConstructHook_String,
                        MUIA_NList_DestructHook, MUIV_NList_DestructHook_String,
                        MUIA_NList_SourceArray, CountryNames,
                        MUIA_CycleChain, TRUE,
                      End,
                    End,
                  End,
                End,
              End,
            End,
            Child, VSpace(0),
          End,
          Child, VGroup,
            Child, VSpace(0),
            Child, VGroup,
              MUIA_Frame, MUIV_Frame_Group,
              MUIA_FrameTitle, msgOtherDetails, //"Additional Details",
              Child, HGroup,
                Child, Label(msgHomePage), //"Home Page"),
                Child, ObjectApp->STR_Page = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_MaxLen, 101,
                  MUIA_ObjectID, OID_PAGE,
                  MUIA_CycleChain, TRUE,
                End,
              End,
              Child, HGroup,
                Child, Label(msgGender), //"Gender"),
                Child, ObjectApp->CY_Sex = CycleObject,
                  MUIA_Cycle_Entries, Sex,
                  MUIA_ObjectID, OID_SEX,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgAge), //"Age"),
                Child, ObjectApp->STR_Age = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_Accept, "0123456789",
                  MUIA_ObjectID, OID_AGE,
                  MUIA_CycleChain, TRUE,
                End,
                Child, ObjectApp->BT_URLCategory = SimpleButton(msgButHomeCat), //"Homepage Category"),
              End,
            End,
            Child, VSpace(0),
            Child, VGroup,
              MUIA_Frame, MUIV_Frame_Group,
              MUIA_FrameTitle, msgBirthDate, //"Birth Date & Horoscope",
              Child, HGroup,
                Child, Label(msgMonth), //"Month"),
                Child, ObjectApp->CY_BDMonth = CycleObject,
                  MUIA_Cycle_Entries, Months,
                  MUIA_ObjectID, OID_BDMONTH,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgDay), //"Day"),
                Child, ObjectApp->STR_BDDay = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_String_Accept, "0123456789",
                  MUIA_ObjectID, OID_BDDAY,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgYear), //"Year"),
                Child, ObjectApp->NU_BDYear = NumericbuttonObject,
                  MUIA_Numeric_Max, 2020,
                  MUIA_Numeric_Min, 1900,
                  MUIA_ObjectID, OID_BDYEAR,
                  MUIA_CycleChain, TRUE,
                End,
              //  Child, Label(msgZodiac), /*"Zodiac"),*/
              //  Child, ObjectApp->GP_DTGroup = GroupObject,
              //    Child, ObjectApp->DT_Zodiac = DatatypeObject,
              //      MUIA_Dtpic_Name, zodiac,
              //    End,
              //  End,
              End,
              Child, HGroup,
                Child, ObjectApp->CH_BDNotify = ImageObject,
                  MUIA_Frame, MUIV_Frame_ImageButton,
                  MUIA_InputMode, MUIV_InputMode_Toggle,
                  MUIA_Image_Spec, MUII_CheckMark,
                  MUIA_Image_FreeVert, TRUE,
                  MUIA_Selected, TRUE,
                  MUIA_Background, MUII_ButtonBack,
                  MUIA_ShowSelState, FALSE,
                  MUIA_ObjectID, OID_BDNOTIFY,
                  MUIA_CycleChain, TRUE,
                End,
                Child, LLabel(msgNotifyEvery1), //"Notify everyone on my birthday"),
                Child, ObjectApp->BT_ViewHoroscope = SimpleButton(msgButViewHor), //"View Horoscope"),
              End,
            End,
            Child, VSpace(0),
            Child, VGroup,
              MUIA_Frame, MUIV_Frame_Group,
              MUIA_FrameTitle, msgSpokeLang, //"Spoken Languages",
              Child, HGroup,
                Child, ObjectApp->CY_Lang1 = CycleObject,
                  MUIA_Cycle_Entries, Languages,
                  MUIA_ObjectID, OID_LANG1,
                  MUIA_CycleChain, TRUE,
                End,
                Child, ObjectApp->CY_Lang2 = CycleObject,
                  MUIA_Cycle_Entries, Languages,
                  MUIA_ObjectID, OID_LANG2,
                  MUIA_CycleChain, TRUE,
                End,
                Child, ObjectApp->CY_Lang3 = CycleObject,
                  MUIA_Cycle_Entries, Languages,
                  MUIA_ObjectID, OID_LANG3,
                  MUIA_CycleChain, TRUE,
                End,
              End,
            End,
            Child, VSpace(0),
          End,
          Child, VGroup,
            Child, CLabel(msgWriteBit), //"Write a bit about your personality, favorites,\nfamily, friends ... so that other ICQ members\nwith similar interests can locate you"),
            Child, ObjectApp->TI_About = TextinputObject,
              MUIA_Frame, MUIV_Frame_String,
              MUIA_Textinput_Multiline, TRUE,
              MUIA_Textinput_Contents, NULL,
              MUIA_Textinput_MaxLen, 512,
              MUIA_ObjectID, OID_ABOUT,
              MUIA_CycleChain, TRUE,
            End,
          End,
          Child, VGroup,
            Child, VSpace(0),
            Child, CLabel(msgSelectUp), //"Select up to three categories and enter\nkeywords to describe specific interests"),
            Child, VSpace(0),
            Child, VGroup,
              MUIA_Frame, MUIV_Frame_Group,
              MUIA_FrameTitle, msgorgaAff, //"Organization, Affiliation, Group",
              MUIA_Group_Columns, 3,
              Child, HSpace(0),
              Child, HSpace(0),
              Child, LLabel(msgEnterName), //"Enter Name(s) or Keywords"),
              Child, ObjectApp->OB_Affiliations[0][0] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Image_FreeVert, TRUE,
                MUIA_Selected, FALSE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_AFFILICH1,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Affiliations[0][1] = CycleObject,
                MUIA_Cycle_Entries, Affiliations,
                MUIA_ObjectID, OID_AFFILICY1,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Affiliations[0][2] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_MaxLen, 61,
                MUIA_ObjectID, OID_KEYWORD1,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Affiliations[1][0] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Image_FreeVert, TRUE,
                MUIA_Selected, FALSE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_AFFILICH2,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Affiliations[1][1] = CycleObject,
                MUIA_Cycle_Entries, Affiliations,
                MUIA_ObjectID, OID_AFFILICY2,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Affiliations[1][2] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_MaxLen, 61,
                MUIA_ObjectID, OID_KEYWORD2,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Affiliations[2][0] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Image_FreeVert, TRUE,
                MUIA_Selected, FALSE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_AFFILICH3,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Affiliations[2][1] = CycleObject,
                MUIA_Cycle_Entries, Affiliations,
                MUIA_ObjectID, OID_AFFILICY3,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Affiliations[2][2] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_MaxLen, 61,
                MUIA_ObjectID, OID_KEYWORD3,
                MUIA_CycleChain, TRUE,
              End,
            End,
            Child, VSpace(0),
            Child, VGroup,
              MUIA_Frame, MUIV_Frame_Group,
              MUIA_FrameTitle, msgPastBack, //"Past Background",
              MUIA_Group_Columns, 3,
              Child, ObjectApp->OB_Pasts[0][0] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Image_FreeVert, TRUE,
                MUIA_Selected, FALSE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_BACKGROUNDCH1,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Pasts[0][1] = CycleObject,
                MUIA_Cycle_Entries, Backgrounds,
                MUIA_ObjectID, OID_BACKGROUNDCY1,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Pasts[0][2] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_MaxLen, 61,
                MUIA_ObjectID, OID_KEYWORD4,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Pasts[1][0] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Image_FreeVert, TRUE,
                MUIA_Selected, FALSE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_BACKGROUNDCH2,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Pasts[1][1] = CycleObject,
                MUIA_Cycle_Entries, Backgrounds,
                MUIA_ObjectID, OID_BACKGROUNDCY2,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Pasts[1][2] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_MaxLen, 61,
                MUIA_ObjectID, OID_KEYWORD5,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Pasts[2][0] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Image_FreeVert, TRUE,
                MUIA_Selected, FALSE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_BACKGROUNDCH3,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Pasts[2][1] = CycleObject,
                MUIA_Cycle_Entries, Backgrounds,
                MUIA_ObjectID, OID_BACKGROUNDCY3,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Pasts[2][2] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_MaxLen, 61,
                MUIA_ObjectID, OID_KEYWORD6,
                MUIA_CycleChain, TRUE,
              End,
            End,
            Child, VSpace(0),
          End,
          Child, VGroup,
            Child, VSpace(0),
            Child, CLabel(msgClicktheEdit), //"Click the Edit button to select a category of\n interest and available interest topics"),
            Child, VSpace(0),
            Child, VGroup,
              MUIA_Frame, MUIV_Frame_Group,
              MUIA_FrameTitle, msgPersInt, //"Personal Interests",
              MUIA_Group_Columns, 3,
              Child, HSpace(0),
              Child, HSpace(0),
              Child, LLabel(msgSelectCat), //"Select Categories"),
              Child, ObjectApp->OB_Interests[0][0] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Image_FreeVert, TRUE,
                MUIA_Selected, FALSE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_SELCAT1,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Interests[0][1] = TextObject,
                MUIA_Frame, MUIV_Frame_Button,
                MUIA_Font, MUIV_Font_Button,
                MUIA_Text_Contents, msgEdit, //"Edit",
                MUIA_Text_PreParse, "\33c",
                MUIA_Weight, 0,
                MUIA_InputMode, MUIV_InputMode_RelVerify,
                MUIA_Background, MUII_ButtonBack,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Interests[0][2] = TextObject,
                MUIA_Background, MUII_TextBack,
                MUIA_Frame, MUIV_Frame_Text,
                MUIA_Text_Contents, NULL,
                MUIA_Text_PreParse, "\033c",
              End,
              Child, ObjectApp->OB_Interests[1][0] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Image_FreeVert, TRUE,
                MUIA_Selected, FALSE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_SELCAT2,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Interests[1][1] = TextObject,
                MUIA_Frame, MUIV_Frame_Button,
                MUIA_Font, MUIV_Font_Button,
                MUIA_Text_Contents, msgEdit, //"Edit",
                MUIA_Text_PreParse, "\33c",
                MUIA_Weight, 0,
                MUIA_InputMode, MUIV_InputMode_RelVerify,
                MUIA_Background, MUII_ButtonBack,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Interests[1][2] = TextObject,
                MUIA_Background, MUII_TextBack,
                MUIA_Frame, MUIV_Frame_Text,
                MUIA_Text_Contents, NULL,
                MUIA_Text_PreParse, "\033c",
              End,
              Child, ObjectApp->OB_Interests[2][0] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Image_FreeVert, TRUE,
                MUIA_Selected, FALSE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_SELCAT3,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Interests[2][1] = TextObject,
                MUIA_Frame, MUIV_Frame_Button,
                MUIA_Font, MUIV_Font_Button,
                MUIA_Text_Contents, msgEdit, //"Edit",
                MUIA_Text_PreParse, "\33c",
                MUIA_Weight, 0,
                MUIA_InputMode, MUIV_InputMode_RelVerify,
                MUIA_Background, MUII_ButtonBack,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Interests[2][2] = TextObject,
                MUIA_Background, MUII_TextBack,
                MUIA_Frame, MUIV_Frame_Text,
                MUIA_Text_Contents, NULL,
                MUIA_Text_PreParse, "\033c",
              End,
              Child, ObjectApp->OB_Interests[3][0] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Image_FreeVert, TRUE,
                MUIA_Selected, FALSE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_SELCAT4,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Interests[3][1] = TextObject,
                MUIA_Frame, MUIV_Frame_Button,
                MUIA_Font, MUIV_Font_Button,
                MUIA_Text_Contents, msgEdit, //"Edit",
                MUIA_Text_PreParse, "\33c",
                MUIA_Weight, 0,
                MUIA_InputMode, MUIV_InputMode_RelVerify,
                MUIA_Background, MUII_ButtonBack,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->OB_Interests[3][2] = TextObject,
                MUIA_Background, MUII_TextBack,
                MUIA_Frame, MUIV_Frame_Text,
                MUIA_Text_Contents, NULL,
                MUIA_Text_PreParse, "\033c",
              End,
            End,
            Child, VSpace(0),
          End,
          Child, VGroup,
            Child, VSpace(0),
            Child, VGroup,
              MUIA_Frame, MUIV_Frame_Group,
              MUIA_FrameTitle, msgSelectPic, //"Select Picture File",
              MUIA_Group_Columns, 2,
              Child, HSpace(0),
              Child, HGroup,
                Child, HSpace(0),
                Child, Label(msgLastUpdate), //"Last Update Date"),
                Child, ObjectApp->TX_PicLastUpdate = TextObject,
                  MUIA_Background, MUII_TextBack,
                  MUIA_Frame, MUIV_Frame_Text,
                  MUIA_Text_Contents, msgNoneAvail, //"None available",
                  MUIA_Text_PreParse, "\033c",
                  MUIA_Weight, 0,
                End,
              End,
              Child, Label(msgPicFile), //"Picture File"),
              Child, HGroup,
                Child, ObjectApp->POP_Picture = PopaslObject,
                  MUIA_Popasl_Type, 0,
                  MUIA_Popstring_String, ObjectApp->STR_Picture = StringObject,
                    MUIA_Frame, MUIV_Frame_String,
                    MUIA_ObjectID, OID_PICTURE,
                    MUIA_String_MaxLen, 256,
                    MUIA_CycleChain, TRUE,
                  End,
                  MUIA_Popstring_Button, PopButton(MUII_PopFile),
                  MUIA_CycleChain, TRUE,
                End,
              End,
              Child, Label(msgFileSize), //"File Size"),
              Child, HGroup,
                Child, ObjectApp->TX_PicSize = TextObject,
                  MUIA_Background, MUII_TextBack,
                  MUIA_Frame, MUIV_Frame_Text,
                  MUIA_Text_Contents, "0kb",
                End,
                Child, ObjectApp->BT_PicClear = TextObject,
                  MUIA_Frame, MUIV_Frame_Button,
                  MUIA_Font, MUIV_Font_Button,
                  MUIA_Text_Contents, msgClear, //"Clear",
                  MUIA_Text_PreParse, "\33c",
                  MUIA_Weight, 0,
                  MUIA_InputMode, MUIV_InputMode_RelVerify,
                  MUIA_Background, MUII_ButtonBack,
                  MUIA_CycleChain, TRUE,
                End,
              End,
            End,
            Child, VSpace(0),
            Child, HGroup,
              Child, VGroup,
                MUIA_Frame, MUIV_Frame_Group,
                MUIA_FrameTitle, msgPicPrivSets, //"Picture Privacy Settings",
                Child, HGroup,
                  Child, ObjectApp->RD_PicPrivacies = RadioObject,
                    MUIA_Radio_Entries, PicPrivacy,
                    MUIA_ObjectID, OID_PICPRIVACIES,
                    MUIA_CycleChain, TRUE,
                  End,
                End,
                Child, HGroup,
                  Child, ObjectApp->CH_PicPrivacy = ImageObject,
                    MUIA_Frame, MUIV_Frame_ImageButton,
                    MUIA_InputMode, MUIV_InputMode_Toggle,
                    MUIA_Image_Spec, MUII_CheckMark,
                    MUIA_Image_FreeVert, TRUE,
                    MUIA_Selected, FALSE,
                    MUIA_Background, MUII_ButtonBack,
                    MUIA_ShowSelState, FALSE,
                    MUIA_ObjectID, OID_PICPRIVACY,
                    MUIA_CycleChain, TRUE,
                  End,
                  Child, LLabel(msgDoNotHavePic), //"Do not have a picture (Auto Decline)"),
                End,
              End,
              Child, VGroup,
                MUIA_Frame, MUIV_Frame_Group,
                MUIA_FrameTitle, msgThumPre, //"Thumbnail Preview",
                Child, HSpace(0),
                Child, CLabel(msgPrevNotYet), //"Preview not yet available"),
                Child, HSpace(0),
              End,
            End,
            Child, VSpace(0),
          End,
          Child, VGroup,
            Child, VSpace(0),
            Child, HGroup,
              MUIA_Frame, MUIV_Frame_Group,
              MUIA_FrameTitle, msgChangeContact, //"Change Contact List Authorization",
              Child, ObjectApp->RD_ReqAuth = RadioObject,
                MUIA_Radio_Entries, Authorization,
                MUIA_ObjectID, OID_REQAUTH,
                MUIA_CycleChain, TRUE,
              End,
              Child, HSpace(0),
            End,
            Child, VSpace(0),
            Child, HGroup,
              MUIA_Frame, MUIV_Frame_Group,
              MUIA_FrameTitle, msgIPPub, //"IP Publishing",
              Child, ObjectApp->CH_HideIP = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Image_FreeVert, TRUE,
                MUIA_Selected, FALSE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_HIDEIP,
                MUIA_CycleChain, TRUE,
              End,
              Child, LLabel(msgDoNotPub), //"Do not publish my IP address"),
              Child, HSpace(0),
            End,
            Child, VSpace(0),
            Child, HGroup,
              MUIA_Frame, MUIV_Frame_Group,
              MUIA_FrameTitle, msgWebAware, //"Web Aware",
              Child, ObjectApp->CH_WebPresence = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Image_FreeVert, TRUE,
                MUIA_Selected, FALSE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_WEBPRESENCE,
                MUIA_CycleChain, TRUE,
              End,
              Child, LLabel(msgAllowUsers), //"Allow others to view my online\npresence on the World Wide Web"),
              Child, HSpace(0),
            End,
            Child, VSpace(0),
            Child, HGroup,
              MUIA_Frame, MUIV_Frame_Group,
              MUIA_FrameTitle, msgChangePass, //"Change Password",
              MUIA_Group_Columns, 2,
              Child, Label(msgPass), //"Password"),
              Child, ObjectApp->STR_ICQPass = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_MaxLen, 9,
                MUIA_String_Secret, TRUE,
                MUIA_ObjectID, OID_PWD,
                MUIA_CycleChain, TRUE,
              End,
              Child, Label(msgVerifyPass), //"Verify Password"),
              Child, ObjectApp->STR_ICQPass2 = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_MaxLen, 9,
                MUIA_String_Secret, TRUE,
                MUIA_CycleChain, TRUE,
              End,
              Child, HSpace(0),
              Child, ObjectApp->BT_ChangePW = SimpleButton(msgButChangePW), //"Save Password"),
            End,
            Child, VSpace(0),
          End,
          Child, VGroup,
            Child, ObjectApp->LV_IgnoreUIN = NListviewObject,
              MUIA_NListview_NList, NListObject,
                MUIA_Frame, MUIV_Frame_InputList,
                MUIA_CycleChain, TRUE,
                MUIA_NList_Title, TRUE,
                MUIA_NList_Format, "BAR,BAR,BAR,",
                MUIA_NList_CompareHook,   &CmpIgnoreHook,
                MUIA_NList_ConstructHook, &AddIgnoreHook,
                MUIA_NList_DestructHook,  &RemIgnoreHook,
                MUIA_NList_DisplayHook,   &DisplayIgnoreHook,
              End,
            End,
            Child, HGroup,
              Child, Label("UIN"),
              Child, ObjectApp->STR_UIN2Ignore = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_Contents, NULL,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->BT_AddIgnore = TextObject,
                MUIA_Frame, MUIV_Frame_Button,
                MUIA_Font, MUIV_Font_Button,
                MUIA_Text_Contents, msgAdd, //"Add",
                MUIA_Text_PreParse, "\33c",
                MUIA_Weight, 0,
                MUIA_InputMode, MUIV_InputMode_RelVerify,
                MUIA_Background, MUII_ButtonBack,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->BT_EditIgnore = TextObject,
                MUIA_Frame, MUIV_Frame_Button,
                MUIA_Font, MUIV_Font_Button,
                MUIA_Text_Contents, msgEdit, //"Edit",
                MUIA_Text_PreParse, "\33c",
                MUIA_Weight, 0,
                MUIA_InputMode, MUIV_InputMode_RelVerify,
                MUIA_Background, MUII_ButtonBack,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->BT_RemIgnore = TextObject,
                MUIA_Frame, MUIV_Frame_Button,
                MUIA_Font, MUIV_Font_Button,
                MUIA_Text_Contents, msgDelete, //"Delete",
                MUIA_Text_PreParse, "\33c",
                MUIA_Weight, 0,
                MUIA_InputMode, MUIV_InputMode_RelVerify,
                MUIA_Background, MUII_ButtonBack,
                MUIA_CycleChain, TRUE,
              End,
            End,
          End,
          Child, VGroup,
            Child, ObjectApp->LV_ICQServers = NListviewObject,
              MUIA_NListview_NList, NListObject,
                MUIA_Frame, MUIV_Frame_InputList,
                MUIA_NList_Format, "PREPARSE=\033c",
                MUIA_NList_ConstructHook, MUIV_NList_ConstructHook_String,
                MUIA_NList_DestructHook, MUIV_NList_DestructHook_String,
              End,
            End,
            Child, HGroup,
              Child, Label(msgServer), //"Server"),
              Child, ObjectApp->STR_TheServer = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_Contents, "icq.mirabilis.com",
                MUIA_ObjectID, OID_THESERVER,
                MUIA_CycleChain, 1,
              End,
              Child, Label(msgPort), //"Port"),
              Child, ObjectApp->STR_ThePort = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_Contents, "4000",
                MUIA_String_Accept, "0123456789",
                MUIA_ObjectID, OID_THEPORT,
                MUIA_Weight, 25,
                MUIA_CycleChain, 1,
              End,
              Child, ObjectApp->BT_AddServer = TextObject,
                MUIA_Frame, MUIV_Frame_Button,
                MUIA_Font, MUIV_Font_Button,
                MUIA_Text_Contents, msgAdd, //"Add",
                MUIA_Text_PreParse, "\33c",
                MUIA_Weight, 0,
                MUIA_InputMode, MUIV_InputMode_RelVerify,
                MUIA_Background, MUII_ButtonBack,
              End,
              Child, ObjectApp->BT_RemServer = TextObject,
                MUIA_Frame, MUIV_Frame_Button,
                MUIA_Font, MUIV_Font_Button,
                MUIA_Text_Contents, msgDelete, //"Delete",
                MUIA_Text_PreParse, "\33c",
                MUIA_Weight, 0,
                MUIA_InputMode, MUIV_InputMode_RelVerify,
                MUIA_Background, MUII_ButtonBack,
              End,
            End,
          End,
          Child, VGroup,
            Child, VSpace(0),
              Child, VGroup,
              //Child, ScrollgroupObject,
              //MUIA_Scrollgroup_FreeHoriz, FALSE,
              //MUIA_Scrollgroup_Contents, VGroupV,
              //MUIA_Frame, MUIV_Frame_Virtual,
                MUIA_Group_Columns, 2,
                Child, Label(msgOnStartup), //"On Startup"),
                Child, ObjectApp->STR_OnStartup = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_ObjectID, OID_ONSTARTUP,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgOnShutDown), //"On Shutdown"),
                Child, ObjectApp->STR_OnShutdown = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_ObjectID, OID_ONSHUTDOWN,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgMsgNotify), //"Message Notify"),
                Child, ObjectApp->STR_MsgNotify = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_ObjectID, OID_MSGNOTIFY,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgMsgPreparse), //"Message PreParse"),
                Child, ObjectApp->STR_MsgPreParse = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_ObjectID, OID_MSGPREPARSE,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgMsgPostparse), //"Message PostParse"),
                Child, ObjectApp->STR_MsgParse = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_ObjectID, OID_MSGPARSE,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgOnlineNotify), //"Online Notify"),
                Child, ObjectApp->STR_OnlineNotify = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_ObjectID, OID_ONNOTIFY,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgOfflineNotify), //"Offline Notify"),
                Child, ObjectApp->STR_OfflineNotify = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_ObjectID, OID_OFFNOTIFY,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgChatNotify), //"Chat Notify"),
                Child, ObjectApp->STR_ChatNotify = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_ObjectID, OID_CHATNOTIFY,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgChatBeep), //"Chat Beep"),
                Child, ObjectApp->STR_ChatBeep = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_ObjectID, OID_CHATBEEP,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgFileDirect), //"FileDirect"),
                Child, ObjectApp->STR_FileDirect = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_ObjectID, OID_FILEDIRECT,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgWinSysMsg), //"System Message"),
                Child, ObjectApp->STR_SysMsg = StringObject,
                  MUIA_Frame, MUIV_Frame_String,
                  MUIA_ObjectID, OID_SYSMSG,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgDownDir), //"Download Dir"),
                Child, HGroup,
                  Child, ObjectApp->POP_DLDir = PopaslObject,
                    MUIA_Popasl_Type, 0,
                    MUIA_Popstring_String, ObjectApp->STR_DownloadDir = StringObject,
                      MUIA_Frame, MUIV_Frame_String,
                      MUIA_ObjectID, OID_DLDIR,
                      MUIA_String_MaxLen, 256,
                      MUIA_CycleChain, TRUE,
                    End,
                    MUIA_Popstring_Button, PopButton(MUII_PopDrawer),
                    MUIA_CycleChain, TRUE,
                  End,
                End,
              End,
            Child, VSpace(0),
            //End,
          End,
          Child, RegisterObject,
            MUIA_Register_Titles, PagesColor,
            MUIA_CycleChain, TRUE,
            Child, VGroup,
              MUIA_Group_Columns, 2,
              Child, Label(msgOnline), //"Online"),
              Child, ObjectApp->PP_StatusColors[0] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, msgWinOnlineColor, //"Online Color",
              End,
              Child, Label(msgOffline), //"Offline"),
              Child, ObjectApp->PP_StatusColors[1] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, msgWinOfflineColor, //"Offline Color",
              End,
              Child, Label(msgInvisible), //"Invisible"),
              Child, ObjectApp->PP_StatusColors[2] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, msgWinInvColor, //"Invisible Color",
              End,
              Child, Label(msgNotAvailable), //"Not Available"),
              Child, ObjectApp->PP_StatusColors[3] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, msgWinNotAvColor, //"Not Available Color",
              End,
              Child, Label(msgFreeForChat), //"Free For Chat"),
              Child, ObjectApp->PP_StatusColors[4] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, msgWinFreeFCColor, //"Free For Chat Color",
              End,
              Child, Label(msgOccupied), //"Occupied"),
              Child, ObjectApp->PP_StatusColors[5] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, msgWinOccColor, //"Occupied Color",
              End,
              Child, Label(msgAway), //"Away"),
              Child, ObjectApp->PP_StatusColors[6] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, msgWinAwayColor, //"Away Color",
              End,
              Child, Label(msgDonot), //"Do Not Disturb"),
              Child, ObjectApp->PP_StatusColors[7] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, msgWinDonotColor, //"Do Not Disturb Color",
              End,
              Child, Label(msgNewusr), //"New User"),
              Child, ObjectApp->PP_StatusColors[8] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, msgWinNewusrColor, //"New User Color",
              End,
            End,
            Child, VGroup,
              MUIA_Group_Columns, 4,
              Child, Label(ChatColorNames[0]),
              Child, ObjectApp->PP_ChatColors[0] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, ChatColorNames[0],
              End,
              Child, Label(ChatColorNames[1]),
              Child, ObjectApp->PP_ChatColors[1] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, ChatColorNames[1],
              End,
              Child, Label(ChatColorNames[2]),
              Child, ObjectApp->PP_ChatColors[2] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, ChatColorNames[2],
              End,
              Child, Label(ChatColorNames[3]),
              Child, ObjectApp->PP_ChatColors[3] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, ChatColorNames[3],
              End,
              Child, Label(ChatColorNames[4]),
              Child, ObjectApp->PP_ChatColors[4] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, ChatColorNames[4],
              End,
              Child, Label(ChatColorNames[5]),
              Child, ObjectApp->PP_ChatColors[5] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, ChatColorNames[5],
              End,
              Child, Label(ChatColorNames[6]),
              Child, ObjectApp->PP_ChatColors[6] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, ChatColorNames[6],
              End,
              Child, Label(ChatColorNames[7]),
              Child, ObjectApp->PP_ChatColors[7] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, ChatColorNames[7],
              End,
              Child, Label(ChatColorNames[8]),
              Child, ObjectApp->PP_ChatColors[8] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, ChatColorNames[8],
              End,
              Child, Label(ChatColorNames[9]),
              Child, ObjectApp->PP_ChatColors[9] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, ChatColorNames[9],
              End,
              Child, Label(ChatColorNames[10]),
              Child, ObjectApp->PP_ChatColors[10] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, ChatColorNames[10],
              End,
              Child, Label(ChatColorNames[11]),
              Child, ObjectApp->PP_ChatColors[11] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, ChatColorNames[11],
              End,
              Child, Label(ChatColorNames[12]),
              Child, ObjectApp->PP_ChatColors[12] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, ChatColorNames[12],
              End,
              Child, Label(ChatColorNames[13]),
              Child, ObjectApp->PP_ChatColors[13] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, ChatColorNames[13],
              End,
              Child, Label(ChatColorNames[14]),
              Child, ObjectApp->PP_ChatColors[14] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, ChatColorNames[14],
              End,
              Child, Label(ChatColorNames[15]),
              Child, ObjectApp->PP_ChatColors[15] = PoppenObject,
                MUIA_CycleChain, TRUE,
                MUIA_InnerLeft, 0,    // Added
                MUIA_InnerRight, 0,   // Added
                MUIA_InnerTop, 0,     // Added
                MUIA_InnerBottom, 0,  // Added
                MUIA_Window_Title, ChatColorNames[15],
              End,
            End,
          End,
          Child, RegisterObject,
            MUIA_Register_Titles, PagesAway,
            MUIA_CycleChain, TRUE,
            Child, VGroup,
              MUIA_Group_Columns, 3,
              Child, Label(msgOnline), //"Online"),
              Child, ObjectApp->STR_Messages[0] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_ObjectID, OID_ONLINEMSG,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->CH_UseMessages[0] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Selected, FALSE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_USEONLINE,
                MUIA_CycleChain, TRUE,
              End,
              Child, Label(msgInvisible), //"Invisible"),
              Child, ObjectApp->STR_Messages[1] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_ObjectID, OID_INVISIBLEMSG,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->CH_UseMessages[1] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Selected, FALSE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_USEINVISIBLE,
                MUIA_CycleChain, TRUE,
              End,
              Child, Label(msgNotAvailable), //"Not Available"),
              Child, ObjectApp->STR_Messages[2] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_ObjectID, OID_NAMSG,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->CH_UseMessages[2] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Selected, TRUE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_USENA,
                MUIA_CycleChain, TRUE,
              End,
              Child, Label(msgFreeForChat), //"Free For Chat"),
              Child, ObjectApp->STR_Messages[3] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_ObjectID, OID_FFCMSG,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->CH_UseMessages[3] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Selected, FALSE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_USEFFC,
                MUIA_CycleChain, TRUE,
              End,
              Child, Label(msgOccupied), //"Occupied"),
              Child, ObjectApp->STR_Messages[4] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_ObjectID, OID_OCCUPIEDMSG,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->CH_UseMessages[4] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Selected, TRUE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_USEOCCUPIED,
                MUIA_CycleChain, TRUE,
              End,
              Child, Label(msgAway), //"Away"),
              Child, ObjectApp->STR_Messages[5] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_ObjectID, OID_AWAYMSG,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->CH_UseMessages[5] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Selected, TRUE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_USEAWAY,
                MUIA_CycleChain, TRUE,
              End,
              Child, Label(msgLab49), //"Do Not Disturb"),
              Child, ObjectApp->STR_Messages[6] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_ObjectID, OID_DNDMSG,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->CH_UseMessages[6] = ImageObject,
                MUIA_Frame, MUIV_Frame_ImageButton,
                MUIA_InputMode, MUIV_InputMode_Toggle,
                MUIA_Image_Spec, MUII_CheckMark,
                MUIA_Selected, TRUE,
                MUIA_Background, MUII_ButtonBack,
                MUIA_ShowSelState, FALSE,
                MUIA_ObjectID, OID_USEDND,
                MUIA_CycleChain, TRUE,
              End,
            End,
            Child, VGroup,
              MUIA_Group_Columns, 2,
              MUIA_ShortHelp, msgHelpStatus, //"Set your status to change after a specified\nnumber of seconds.  Use 0 to disable.\nTimes are cumulative.  Resolution of 5 seconds.",
              Child, CLabel(msgChangeStat), //"Change status to:"),
              Child, CLabel(msgChangeStat2), //("After this many seconds:"),
              Child, ObjectApp->CY_SetStatus[0] = CycleObject,
                MUIA_Cycle_Entries, Statii,
                MUIA_ObjectID, OID_SETSTATUS0,
                MUIA_Weight, 0,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->STR_TimedStatus[0] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_Integer, 0,
                MUIA_ObjectID, OID_TIMEDSTATUS0,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->CY_SetStatus[1] = CycleObject,
                MUIA_Cycle_Entries, Statii,
                MUIA_ObjectID, OID_SETSTATUS1,
                MUIA_Weight, 0,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->STR_TimedStatus[1] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_Integer, 0,
                MUIA_ObjectID, OID_TIMEDSTATUS1,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->CY_SetStatus[2] = CycleObject,
                MUIA_Cycle_Entries, Statii,
                MUIA_ObjectID, OID_SETSTATUS2,
                MUIA_Weight, 0,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->STR_TimedStatus[2] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_Integer, 0,
                MUIA_ObjectID, OID_TIMEDSTATUS2,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->CY_SetStatus[3] = CycleObject,
                MUIA_Cycle_Entries, Statii,
                MUIA_ObjectID, OID_SETSTATUS3,
                MUIA_Weight, 0,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->STR_TimedStatus[3] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_Integer, 0,
                MUIA_ObjectID, OID_TIMEDSTATUS3,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->CY_SetStatus[4] = CycleObject,
                MUIA_Cycle_Entries, Statii,
                MUIA_ObjectID, OID_SETSTATUS4,
                MUIA_Weight, 0,
                MUIA_CycleChain, TRUE,
              End,
              Child, ObjectApp->STR_TimedStatus[4] = StringObject,
                MUIA_Frame, MUIV_Frame_String,
                MUIA_String_Integer, 0,
                MUIA_ObjectID, OID_TIMEDSTATUS4,
                MUIA_CycleChain, TRUE,
              End,
            End,
          End,
          Child, RegisterObject,
            MUIA_Register_Titles, PagesOpts,
            MUIA_CycleChain, TRUE,
            Child, VGroup,
            Child, VSpace(0),
              Child, VGroup,
                MUIA_Group_Columns, 6,
                MUIA_Frame, MUIV_Frame_Group,
                MUIA_FrameTitle, msgGlobalOptions, //"Global Options",
                Child, HSpace(0),
                Child, Label(msgopenlogWin), //"Open Log Window"),
                Child, ObjectApp->CH_OpenLog = ImageObject,
                  MUIA_Frame, MUIV_Frame_ImageButton,
                  MUIA_InputMode, MUIV_InputMode_Toggle,
                  MUIA_Image_Spec, MUII_CheckMark,
                  MUIA_Image_FreeVert, TRUE,
                  MUIA_Selected, FALSE,
                  MUIA_Background, MUII_ButtonBack,
                  MUIA_ShowSelState, FALSE,
                  MUIA_ObjectID, OID_AUTOLOG,
                  MUIA_CycleChain, TRUE,
                End,
                Child, ObjectApp->CH_Reconnect = ImageObject,
                  MUIA_Frame, MUIV_Frame_ImageButton,
                  MUIA_InputMode, MUIV_InputMode_Toggle,
                  MUIA_Image_Spec, MUII_CheckMark,
                  MUIA_Image_FreeVert, TRUE,
                  MUIA_Selected, TRUE,
                  MUIA_Background, MUII_ButtonBack,
                  MUIA_ShowSelState, FALSE,
                  MUIA_ObjectID, OID_RECONNECT,
                  MUIA_CycleChain, TRUE,
                End,
                Child, LLabel(msgAutoRecon), //"Auto Reconnect"),
                Child, HSpace(0),
                Child, HSpace(0),
                Child, Label(msgLab78), //"Open Message Win"),
                Child, ObjectApp->CH_OpenMsg = ImageObject,
                  MUIA_Frame, MUIV_Frame_ImageButton,
                  MUIA_InputMode, MUIV_InputMode_Toggle,
                  MUIA_Image_Spec, MUII_CheckMark,
                  MUIA_Image_FreeVert, TRUE,
                  MUIA_Selected, FALSE,
                  MUIA_Background, MUII_ButtonBack,
                  MUIA_ShowSelState, FALSE,
                  MUIA_ObjectID, OID_OPENMSGWIN,
                  MUIA_CycleChain, TRUE,
                End,
                Child, ObjectApp->CH_MsgTime = ImageObject,
                  MUIA_Frame, MUIV_Frame_ImageButton,
                  MUIA_InputMode, MUIV_InputMode_Toggle,
                  MUIA_Image_Spec, MUII_CheckMark,
                  MUIA_Image_FreeVert, TRUE,
                  MUIA_Selected, TRUE,
                  MUIA_Background, MUII_ButtonBack,
                  MUIA_ShowSelState, FALSE,
                  MUIA_ObjectID, OID_MSGTIME,
                  MUIA_CycleChain, TRUE,
                End,
                Child, LLabel(msgLogLab25), //"Show Message Time"),
                Child, HSpace(0),
                Child, HSpace(0),
                Child, Label(msgActNameSort), //"Activity Name Sort"),
                Child, ObjectApp->CH_ActySort = ImageObject,
                  MUIA_Frame, MUIV_Frame_ImageButton,
                  MUIA_InputMode, MUIV_InputMode_Toggle,
                  MUIA_Image_Spec, MUII_CheckMark,
                  MUIA_Image_FreeVert, TRUE,
                  MUIA_Selected, FALSE,
                  MUIA_Background, MUII_ButtonBack,
                  MUIA_ShowSelState, FALSE,
                  MUIA_ObjectID, OID_ACTYSORT,
                  MUIA_CycleChain, TRUE,
                End,
                Child, ObjectApp->CH_MultiLine = ImageObject,
                  MUIA_Frame, MUIV_Frame_ImageButton,
                  MUIA_InputMode, MUIV_InputMode_Toggle,
                  MUIA_Image_Spec, MUII_CheckMark,
                  MUIA_Image_FreeVert, TRUE,
                  MUIA_Selected, FALSE,
                  MUIA_Background, MUII_ButtonBack,
                  MUIA_ShowSelState, FALSE,
                  MUIA_ObjectID, OID_MULTILINE,
                  MUIA_CycleChain, TRUE,
                End,
                Child, LLabel(msgMultiLine), //"Multi-Line Message Input"),
                Child, HSpace(0),
                Child, HSpace(0),
                Child, Label(msgUseTime), //"Use Internet Time"),
                Child, ObjectApp->CH_UseBeats = ImageObject,
                  MUIA_Frame, MUIV_Frame_ImageButton,
                  MUIA_InputMode, MUIV_InputMode_Toggle,
                  MUIA_Image_Spec, MUII_CheckMark,
                  MUIA_Image_FreeVert, TRUE,
                  MUIA_Selected, FALSE,
                  MUIA_Background, MUII_ButtonBack,
                  MUIA_ShowSelState, FALSE,
                  MUIA_ObjectID, OID_USEBEATS,
                  MUIA_CycleChain, TRUE,
                End,
                Child, HSpace(0),
                Child, HSpace(0),
                Child, HSpace(0),
              End,
              Child, VSpace(0),
              Child, VGroup,
                MUIA_Group_Columns, 2,
                MUIA_Frame, MUIV_Frame_Group,
                MUIA_FrameTitle, msgSelections, //"Selections",
                Child, Label(msgNotLamp), //"Notify Lamp"),
                Child, ObjectApp->CY_Lamp = CycleObject,
                  MUIA_Cycle_Entries, Lamps,
                  MUIA_ObjectID, OID_LAMP,
                  MUIA_CycleChain, TRUE,
                End,
                Child, Label(msgUDPProt), //"UDP Protocol"),
                Child, ObjectApp->CY_UDPVersion = CycleObject,
                  MUIA_Cycle_Entries, UDPVersion,
                  MUIA_ObjectID, OID_UDPVERSION,
                  MUIA_CycleChain, TRUE,
                End,
              End,
              Child, VSpace(0),
              Child, VGroup,
                MUIA_Group_Columns, 6,
                MUIA_Frame, MUIV_Frame_Group,
                MUIA_FrameTitle, msgMsgOpts, //"Message Options",
                Child, HSpace(0),
                Child, Label(msgLabWinPop), //"Window Pop-Up"),
                Child, ObjectApp->CH_MsgPopup = ImageObject,
                  MUIA_Frame, MUIV_Frame_ImageButton,
                  MUIA_InputMode, MUIV_InputMode_Toggle,
                  MUIA_Image_Spec, MUII_CheckMark,
                  MUIA_Image_FreeVert, TRUE,
                  MUIA_Selected, FALSE,
                  MUIA_Background, MUII_ButtonBack,
                  MUIA_ShowSelState, FALSE,
                  MUIA_ObjectID, OID_MSGPOPUP,
                  MUIA_CycleChain, TRUE,
                End,
                Child, ObjectApp->CH_Scrn2Frnt = ImageObject,
                  MUIA_Frame, MUIV_Frame_ImageButton,
                  MUIA_InputMode, MUIV_InputMode_Toggle,
                  MUIA_Image_Spec, MUII_CheckMark,
                  MUIA_Image_FreeVert, TRUE,
                  MUIA_Selected, FALSE,
                  MUIA_Background, MUII_ButtonBack,
                  MUIA_ShowSelState, FALSE,
                  MUIA_ObjectID, OID_SCRN2FRNT,
                  MUIA_CycleChain, TRUE,
                End,
                Child, LLabel(msgScreen2Front), //"Screen To Front"),
                Child, HSpace(0),
                Child, HSpace(0),
                Child, Label(msgLabNoMsgLog), //"No Message Log"),
                Child, ObjectApp->CH_NoMsgLog = ImageObject,
                  MUIA_Frame, MUIV_Frame_ImageButton,
                  MUIA_InputMode, MUIV_InputMode_Toggle,
                  MUIA_Image_Spec, MUII_CheckMark,
                  MUIA_Image_FreeVert, TRUE,
                  MUIA_Selected, FALSE,
                  MUIA_Background, MUII_ButtonBack,
                  MUIA_ShowSelState, FALSE,
                  MUIA_ObjectID, OID_NOMSGLOG,
                  MUIA_CycleChain, TRUE,
                End,
                Child, HSpace(0),
                Child, HSpace(0),
                Child, HSpace(0),
              End,
            Child, VSpace(0),
            End,
            Child, HGroup,
              Child, GroupObject,
                MUIA_Frame, MUIV_Frame_Group,
                MUIA_FrameTitle, msgStorage, //"Storage",
                Child, ObjectApp->LV_ColsStore = NListviewObject,
                  MUIA_NListview_NList, ObjectApp->LV_StoreUser = NewObject(mcc_Cols->mcc_Class,NULL,
                    MUIA_Frame, MUIV_Frame_ReadList,
                    MUIA_CycleChain, TRUE,
                    MUIA_NList_DragType, MUIV_NList_DragType_Immediate,
                    MUIA_NList_ShowDropMarks, FALSE,
                    MUIA_NList_CompareHook,   &CmpColsHook,
                    MUIA_NList_ConstructHook, &AddColsHook,
                    MUIA_NList_DestructHook,  &RemColsHook,
                    MUIA_NList_DisplayHook,   &DisplayColsHook,
                  End,
                End,
              End,
              Child, GroupObject,
                MUIA_Frame, MUIV_Frame_Group,
                MUIA_FrameTitle, msgActive, //"Active",
                Child, ObjectApp->LV_ColsUse = NListviewObject,
                  MUIA_NListview_NList, ObjectApp->LV_UseUser = NewObject(mcc_Cols->mcc_Class,NULL,
                    MUIA_Frame, MUIV_Frame_ReadList,
                    MUIA_CycleChain, TRUE,
                    MUIA_NList_DragSortable, TRUE,
                    MUIA_NList_DragType, MUIV_NList_DragType_Immediate,
                    MUIA_NList_ShowDropMarks, TRUE,
                    MUIA_NList_CompareHook,   &CmpColsHook,
                    MUIA_NList_ConstructHook, &AddColsHook,
                    MUIA_NList_DestructHook,  &RemColsHook,
                    MUIA_NList_DisplayHook,   &DisplayColsHook,
                  End,
                End,
              End,
            End,
          End,
        End,
      End,
      Child, HGroup,
        Child, ObjectApp->BT_GrabMyStats = SimpleButton(msgButRetFrom), //"Retrieve From Server"),
        Child, ObjectApp->BT_UpUInfo1 = SimpleButton(msgSaveTo), //"Save To Server"),
      End,
    End,
  End,
End;


if (!(ObjectApp->TX_Timer = NewObject(mcc_Time->mcc_Class,NULL,
  TIME_SetSecs, 120,
  TIME_SetMicro, 0,
  TIME_SetTrg, TIME_Trigger,
  TAG_DONE)))
         {
             sprintf(nogfx,"%s",msgFailTime);
             fail(NULL,nogfx); //"Could not create Keep-Alive Timer object.");
         }
if (!(ObjectApp->TX_Timer1 = NewObject(mcc_Time->mcc_Class,NULL,
  TIME_SetSecs, 10,
  TIME_SetMicro, 0,
  TIME_SetTrg, TIME_Trigger1,
  TAG_DONE)))
         {
             sprintf(nogfx,"%s",msgFailTime2);
             fail(NULL,nogfx); //"Could not create Command-Resend Timer object.");
         }
if (!(ObjectApp->CC_Parse = NewObject(mcc_Time->mcc_Class,NULL,
  TIME_SetSecs, 0,
  TIME_SetMicro, 250000,
  TIME_SetTrg, TIME_Trigger_Parse,
  TAG_DONE)))
         {
             sprintf(nogfx,"%s",msgFailTime3);
             fail(NULL,nogfx); //"Could not create Command-Parser Timer object.");
         }
if (!(ObjectApp->TX_Port = NewObject(mcc_Port->mcc_Class,NULL,NULL)))  fail(NULL,"Could not create Port object.");

if (!ObjectApp->App) {
  FreeVec(ObjectApp);
  return(NULL);
}

set(ObjectApp->BT_AddContact,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_RemContact,MUIA_CycleChain,TRUE);

set(ObjectApp->BT_ReplyMessage,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_GetInfo,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_RemMessage,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_ClearMsgs,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_Auth,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_OpenURLWin,MUIA_CycleChain,TRUE);

set(ObjectApp->BT_AddUpdate2,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_GetInfo3,MUIA_CycleChain,TRUE);

set(ObjectApp->BT_URLSend,MUIA_CycleChain,TRUE);

set(ObjectApp->BT_AdOK,MUIA_CycleChain,TRUE);

set(ObjectApp->BT_SendChat,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_JoinChat,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_CancelChat,MUIA_CycleChain,TRUE);

set(ObjectApp->BT_Sendit,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_ChangePW,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_UpUInfo1,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_GrabMyStats,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_StartSrch,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_AddUpdate,MUIA_CycleChain,TRUE);

set(ObjectApp->BT_AddFile,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_RemFile,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_SendFile,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_CancelFile,MUIA_CycleChain,TRUE);

set(ObjectApp->BT_AddUIN,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_AddCancel,MUIA_CycleChain,TRUE);

set(ObjectApp->BT_AddCancel,MUIA_CycleChain,TRUE);

set(ObjectApp->BT_ErrClr,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_ErrSave,MUIA_CycleChain,TRUE);

set(ObjectApp->BT_IgnoreOK,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_IgnoreCanx,MUIA_CycleChain,TRUE);

set(ObjectApp->BT_DisplayMap,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_DisplayWkMap,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_URLCategory,MUIA_CycleChain,TRUE);
set(ObjectApp->BT_ViewHoroscope,MUIA_CycleChain,TRUE);

set(ObjectApp->LV_StoreUser,MUIA_UserData,ObjectApp->LV_UseUser);
set(ObjectApp->LV_UseUser,MUIA_UserData,ObjectApp->LV_StoreUser);

DoMethod(ObjectApp->BT_AddContact, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->WI_Searches, 3,
         MUIM_Set, MUIA_Window_Open, TRUE);

DoMethod(ObjectApp->BT_ChangePW, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_ChangePW, 2,
         MUIM_CallHook, &ChangePWHook);

DoMethod(ObjectApp->BT_UpUInfo1, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_UpUInfo1, 2,
         MUIM_CallHook, &SendUInfo1Hook);

DoMethod(ObjectApp->BT_ReplyMessage, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_ReplyMessage, 2,
         MUIM_CallHook, &SendMessageHook);

DoMethod(ObjectApp->BT_Sendit, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_Sendit, 2,
         MUIM_CallHook, &SendMsg2ICQHook);

DoMethod(ObjectApp->BT_Auth, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_Auth, 2,
         MUIM_CallHook, &SendMsg2ICQHook);

DoMethod(ObjectApp->BT_OpenURLWin, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_OpenURLWin, 2,
         MUIM_CallHook, &SendMessageHook);

DoMethod(ObjectApp->BT_URLSend, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_URLSend, 2,
         MUIM_CallHook, &SendMsg2ICQHook);

DoMethod(ObjectApp->TI_QuickMsg, MUIM_Notify, MUIA_Textinput_Acknowledge, MUIV_EveryTime, ObjectApp->TI_QuickMsg, 2,
         MUIM_CallHook, &SendMsg2ICQHook);

DoMethod(ObjectApp->BT_GetInfo, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_GetInfo, 2,
         MUIM_CallHook, &GetUINInfoHook);

DoMethod(ObjectApp->BT_GetInfo3, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_GetInfo3, 2,
         MUIM_CallHook, &GetUINInfoHook);

DoMethod(ObjectApp->BT_GrabMyStats, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_GrabMyStats, 2,
         MUIM_CallHook, &GetUINInfoHook);

DoMethod(ObjectApp->BT_AddUpdate, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_AddUpdate, 2,
         MUIM_CallHook, &AddUpdateHook);

DoMethod(ObjectApp->BT_AddUpdate2, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_AddUpdate2, 2,
         MUIM_CallHook, &AddUpdateHook);

DoMethod(ObjectApp->BT_StartSrch, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_StartSrch, 2,
         MUIM_CallHook, &AddContactHook);


DoMethod(ObjectApp->DL_UINList, MUIM_Notify, MUIA_Listview_DoubleClick, MUIV_EveryTime, ObjectApp->POP_SelectUIN, 2,
         MUIM_Popstring_Close, TRUE);

DoMethod(ObjectApp->LV_Countries, MUIM_Notify, MUIA_NList_EntryClick, MUIV_EveryTime, ObjectApp->POP_Country, 2,
         MUIM_Popstring_Close, TRUE);


DoMethod(ObjectApp->LV_ICQSrvLog, MUIM_Notify, MUIA_NList_Entries, MUIV_EveryTime, ObjectApp->LV_ICQSrvLog, 2,
         MUIM_NList_Jump, MUIV_NList_Jump_Bottom);

DoMethod(ObjectApp->LV_ICQCliLog, MUIM_Notify, MUIA_NList_Entries, MUIV_EveryTime, ObjectApp->LV_ICQCliLog, 2,
         MUIM_NList_Jump, MUIV_NList_Jump_Bottom);

DoMethod(ObjectApp->LV_Activity, MUIM_Notify, MUIA_NList_Entries, MUIV_EveryTime, ObjectApp->LV_Activity, 2,
         MUIM_NList_Jump, MUIV_NList_Jump_Bottom);


DoMethod(ObjectApp->CH_MsgTime, MUIM_Notify, MUIA_Selected, TRUE, ObjectApp->LV_Msgs, 3,
         MUIM_Set, MUIA_NList_Format, "BAR,BAR,");

DoMethod(ObjectApp->CH_MsgTime, MUIM_Notify, MUIA_Selected, FALSE, ObjectApp->LV_Msgs, 3,
         MUIM_Set, MUIA_NList_Format, "COL=0 BAR,COL=2");

DoMethod(ObjectApp->CH_ActySort, MUIM_Notify, MUIA_Selected, MUIV_EveryTime, ObjectApp->LV_Activity, 1,
         MUIM_NList_Sort);


DoMethod(ObjectApp->BT_RemContact, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_RemContact, 2,
         MUIM_CallHook, &RemoveContactHook);

DoMethod(ObjectApp->BT_RemMessage, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->LV_Msgs, 2,
         MUIM_NList_Remove, MUIV_NList_Remove_Selected);

DoMethod(ObjectApp->BT_ClearMsgs, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->LV_Msgs, 1,
         MUIM_NList_Clear);

DoMethod(ObjectApp->CY_MyStatus, MUIM_Notify, MUIA_Cycle_Active, MUIV_EveryTime, ObjectApp->CY_MyStatus, 2,
         MUIM_CallHook, &ChangeMyStatusHook);

DoMethod(ObjectApp->LV_Msgs, MUIM_Notify, MUIA_NList_EntryClick, MUIV_EveryTime, ObjectApp->LV_Msgs, 2,
         MUIM_CallHook, &SetQuickToHook);

DoMethod(ObjectApp->LV_Msgs, MUIM_Notify, MUIA_NList_DoubleClick, MUIV_EveryTime, ObjectApp->LV_Msgs, 2,
         MUIM_CallHook, &GoURLHook);

DoMethod(ObjectApp->LV_OfflineList, MUIM_Notify, MUIA_NList_DoubleClick, MUIV_EveryTime, ObjectApp->LV_OfflineList, 2,
         MUIM_CallHook, &NewUserWinHook);


DoMethod(ObjectApp->BT_RemServer, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->LV_ICQServers, 2,
         MUIM_NList_Remove, MUIV_NList_Remove_Selected);

DoMethod(ObjectApp->BT_AddServer, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_AddServer, 2,
         MUIM_CallHook, &AddServerHook);

DoMethod(ObjectApp->LV_ICQServers, MUIM_Notify, MUIA_NList_EntryClick, MUIV_EveryTime, ObjectApp->LV_ICQServers, 2,
         MUIM_CallHook, &AddServerHook);

DoMethod(ObjectApp->BT_RemIgnore, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->LV_IgnoreUIN, 2,
         MUIM_NList_Remove, MUIV_NList_Remove_Selected);

DoMethod(ObjectApp->BT_AddIgnore, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_AddIgnore, 2,
         MUIM_CallHook, &Add2IgnoreHook);


DoMethod(ObjectApp->CH_SearchUIN, MUIM_Notify, MUIA_Selected, TRUE, ObjectApp->CH_SearchUIN, 8,
         MUIM_MultiSet, MUIA_Disabled, TRUE, ObjectApp->STR_SrchEMail, ObjectApp->STR_SrchNick, ObjectApp->STR_SrchFirst,
         ObjectApp->STR_SrchLast, NULL);

DoMethod(ObjectApp->CH_SearchUIN, MUIM_Notify, MUIA_Selected, TRUE, ObjectApp->STR_SrchUIN, 3,
         MUIM_Set, MUIA_Disabled, FALSE);

DoMethod(ObjectApp->CH_SearchUIN, MUIM_Notify, MUIA_Selected, TRUE, ObjectApp->CH_SearchUIN, 6,
         MUIM_MultiSet, MUIA_Selected, FALSE, ObjectApp->CH_SearchEMail, ObjectApp->CH_SearchName, NULL);

DoMethod(ObjectApp->CH_SearchEMail, MUIM_Notify, MUIA_Selected, TRUE, ObjectApp->CH_SearchEMail, 8,
         MUIM_MultiSet, MUIA_Disabled, TRUE, ObjectApp->STR_SrchUIN, ObjectApp->STR_SrchNick, ObjectApp->STR_SrchFirst,
         ObjectApp->STR_SrchLast, NULL);

DoMethod(ObjectApp->CH_SearchEMail, MUIM_Notify, MUIA_Selected, TRUE, ObjectApp->STR_SrchEMail, 3,
         MUIM_Set, MUIA_Disabled, FALSE);

DoMethod(ObjectApp->CH_SearchEMail, MUIM_Notify, MUIA_Selected, TRUE, ObjectApp->CH_SearchEMail, 6,
         MUIM_MultiSet, MUIA_Selected, FALSE, ObjectApp->CH_SearchUIN, ObjectApp->CH_SearchName, NULL);

DoMethod(ObjectApp->CH_SearchName, MUIM_Notify, MUIA_Selected, TRUE, ObjectApp->CH_SearchName, 6,
         MUIM_MultiSet, MUIA_Disabled, TRUE, ObjectApp->STR_SrchUIN, ObjectApp->STR_SrchEMail, NULL);

DoMethod(ObjectApp->CH_SearchName, MUIM_Notify, MUIA_Selected, TRUE, ObjectApp->CH_SearchName, 7,
         MUIM_MultiSet, MUIA_Disabled, FALSE, ObjectApp->STR_SrchNick, ObjectApp->STR_SrchFirst, ObjectApp->STR_SrchLast, NULL);

DoMethod(ObjectApp->CH_SearchName, MUIM_Notify, MUIA_Selected, TRUE, ObjectApp->CH_SearchName, 6,
         MUIM_MultiSet, MUIA_Selected, FALSE, ObjectApp->CH_SearchEMail, ObjectApp->CH_SearchUIN, NULL);


for(i = 0; i < NUM_STATUS_COLORS; i++) {
  DoMethod(ObjectApp->PP_StatusColors[i], MUIM_Notify, MUIA_Pendisplay_Spec, MUIV_EveryTime, ObjectApp->TX_Color, 3,
           MUIM_Set, TAG_USER + i, MUIV_TriggerValue);
}

for(i = 0; i < NUM_CHAT_COLORS; i++) {
  DoMethod(ObjectApp->PP_ChatColors[i], MUIM_Notify, MUIA_Pendisplay_Spec, MUIV_EveryTime, ObjectApp->TX_Color, 3,
           MUIM_Set, TAG_USER + 100 + i, MUIV_TriggerValue);
}


DoMethod(ObjectApp->BT_AdOK, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->WI_URLMessage, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->BT_AdGoURL, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_AdGoURL, 2,
         MUIM_CallHook, &GoURLHook);

DoMethod(ObjectApp->TX_UserURL, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->TX_UserURL, 2,
         MUIM_CallHook, &GoURLHook);


DoMethod(ObjectApp->DL_MsgDir, MUIM_Notify, MUIA_Listview_DoubleClick, MUIV_EveryTime, ObjectApp->DL_MsgDir, 2,
         MUIM_CallHook, &ViewHistoryHook);


DoMethod(ObjectApp->BT_SendChat, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_SendChat, 2,
         MUIM_CallHook, &SendChatReqHook);

DoMethod(ObjectApp->BT_JoinChat, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_JoinChat, 2,
         MUIM_CallHook, &SendChatReqHook);

DoMethod(ObjectApp->BT_CancelChat, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->WI_ChatReqOut, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);


DoMethod(ObjectApp->BT_CancelFile, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->WI_FileSendOut, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->BT_SendFile, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_SendFile, 2,
         MUIM_CallHook, &SendFileSendHook);

DoMethod(ObjectApp->BT_RemFile, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->LV_FileList, 2,
         MUIM_NList_Remove, MUIV_NList_Remove_Selected);

DoMethod(ObjectApp->BT_RemFile, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_RemFile, 2,
         MUIM_CallHook, &SetFileSendStatsHook);

DoMethod(ObjectApp->BT_AddFile, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_AddFile, 2,
         MUIM_CallHook, &AddFiles2SendHook);


DoMethod(ObjectApp->BT_AddUIN, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_AddUIN, 2,
         MUIM_CallHook, &GetAddUINInfoHook);

DoMethod(ObjectApp->BT_AddCancel, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->WI_AddUIN, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);


DoMethod(ObjectApp->BT_ErrClr, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->LV_Errors, 1,
         MUIM_NList_Clear);

DoMethod(ObjectApp->BT_ErrSave, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_ErrSave, 2,
         MUIM_CallHook, &SaveErrorsHook);


DoMethod(ObjectApp->BT_EditIgnore, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_EditIgnore, 2,
         MUIM_CallHook, &OpenEditIgnoreHook);

DoMethod(ObjectApp->BT_IgnoreOK, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->BT_IgnoreOK, 2,
         MUIM_CallHook, &SetIgnoreEditsHook);

DoMethod(ObjectApp->BT_IgnoreCanx, MUIM_Notify, MUIA_Pressed, FALSE, ObjectApp->WI_EditIgnore, 2,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->LV_IgnoreUIN, MUIM_Notify, MUIA_NList_DoubleClick, MUIV_EveryTime, ObjectApp->LV_IgnoreUIN, 2,
         MUIM_CallHook, &OpenEditIgnoreHook);

/*
** WI_ICQPrefs
*/

DoMethod(ObjectApp->LV_InfoPages, MUIM_Notify, MUIA_NList_EntryClick, MUIV_EveryTime, ObjectApp->GP_InfoPages, 3,
         MUIM_Set, MUIA_Group_ActivePage, MUIV_TriggerValue);

DoMethod(ObjectApp->LV_WkCountries, MUIM_Notify, MUIA_NList_EntryClick, MUIV_EveryTime, ObjectApp->POP_WkCountry, 2,
         MUIM_Popstring_Close, TRUE);

for(i = 0; i < NUM_AFFILIATIONS; i++) {
  DoMethod(ObjectApp->OB_Affiliations[i][0], MUIM_Notify, MUIA_Selected, MUIV_EveryTime, ObjectApp->WI_ICQPrefs, 6,
         MUIM_MultiSet, MUIA_Disabled, MUIV_NotTriggerValue, ObjectApp->OB_Affiliations[i][1], ObjectApp->OB_Affiliations[i][2], NULL);
}

for(i = 0; i < NUM_PASTS; i++) {
  DoMethod(ObjectApp->OB_Pasts[i][0], MUIM_Notify, MUIA_Selected, MUIV_EveryTime, ObjectApp->WI_ICQPrefs, 6,
         MUIM_MultiSet, MUIA_Disabled, MUIV_NotTriggerValue, ObjectApp->OB_Pasts[i][1], ObjectApp->OB_Pasts[i][2], NULL);
}

for(i = 0; i < NUM_INTERESTS; i++) {
  DoMethod(ObjectApp->OB_Interests[i][0], MUIM_Notify, MUIA_Selected, MUIV_EveryTime, ObjectApp->WI_ICQPrefs, 6,
         MUIM_MultiSet, MUIA_Disabled, MUIV_NotTriggerValue, ObjectApp->OB_Interests[i][1], ObjectApp->OB_Interests[i][2], NULL);
}

DoMethod(ObjectApp->CH_PicPrivacy, MUIM_Notify, MUIA_Selected, MUIV_EveryTime, ObjectApp->RD_PicPrivacies, 3,
         MUIM_Set, MUIA_Disabled, MUIV_TriggerValue);

DoMethod(ObjectApp->CY_BDMonth, MUIM_Notify, MUIA_Cycle_Active, MUIV_EveryTime, ObjectApp->CY_BDMonth, 2,
         MUIM_CallHook, &ChangeZodiacHook);

DoMethod(ObjectApp->STR_BDDay, MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime, ObjectApp->CY_BDMonth, 2,
         MUIM_CallHook, &ChangeZodiacHook);

/*
** Window Close Gadgets
*/

DoMethod(ObjectApp->WI_Main, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_Main, 2,
         MUIM_CallHook, &DisconnectICQHook);

DoMethod(ObjectApp->WI_Main, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->App, 2,
         MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit);

DoMethod(ObjectApp->WI_About, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_About, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_Log, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_Log, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_Message, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_Message, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_Send, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_Send, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_Information, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_Information, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_Searches, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_Searches, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_SrchResults, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_SrchResults, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_SendURL, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_SendURL, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_URLMessage, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_URLMessage, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_MessageHist, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_MessageHist, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_Activities, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_Activities, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_Sockets, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_Sockets, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_ChatReqOut, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_ChatReqOut, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_FileSendOut, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_FileSendOut, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_AddUIN, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_AddUIN, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_WebPager, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_WebPager, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_ErrorWin, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_ErrorWin, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_EditIgnore, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_EditIgnore, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

DoMethod(ObjectApp->WI_ICQPrefs, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, ObjectApp->WI_ICQPrefs, 3,
         MUIM_Set, MUIA_Window_Open, FALSE);

/*
** Menu Commands
*/

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_ABOUT),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->WI_About, 3,
         MUIM_Set, MUIA_Window_Open, TRUE);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_NEWUIN),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->WI_ICQPrefs, 2,
         MUIM_CallHook, &NewUINHook);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_QUIT),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->App, 2,
         MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_SAVEPREF),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->WI_ICQPrefs, 2,
         MUIM_CallHook, &SavePrefsHook);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_MUI),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, MUIV_Notify_Application, 2,
         MUIM_Application_OpenConfigWindow, 0);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_LOGWIN),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->WI_Log, 3,
         MUIM_Set, MUIA_Window_Open, TRUE);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_MSGWIN),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->WI_Message, 3,
         MUIM_Set, MUIA_Window_Open, TRUE);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_URLWIN),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->WI_URLMessage, 3,
         MUIM_Set, MUIA_Window_Open, TRUE);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_INFOWIN),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->WI_Information, 3,
         MUIM_Set, MUIA_Window_Open, TRUE);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_ACTIVITY),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->WI_Activities, 3,
         MUIM_Set, MUIA_Window_Open, TRUE);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_ABOUTMUI),
           MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, MUIV_Notify_Application, 2,
         MUIM_Application_AboutMUI, ObjectApp->WI_Main);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_SAVEMSGS),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->LV_Msgs, 2,
         MUIM_CallHook, &SaveMsgWinHook);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_SEARCH),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->WI_Searches, 3,
         MUIM_Set, MUIA_Window_Open, TRUE);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_CONNECTIONS),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->App, 6,
         MUIM_Application_PushMethod, ObjectApp->WI_Sockets, 3, MUIM_Set, MUIA_Window_Open, TRUE);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_HISTORY),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->WI_MessageHist, 3,
         MUIM_CallHook, &ViewHistoryHook);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_PAGER),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->WI_WebPager, 3,
         MUIM_Set, MUIA_Window_Open, TRUE);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_ERRWIN),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->WI_ErrorWin, 3,
         MUIM_Set, MUIA_Window_Open, TRUE);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_ICQPREFS),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->WI_ICQPrefs, 3,
         MUIM_Set, MUIA_Window_Open, TRUE);

DoMethod((Object *)DoMethod(ObjectApp->NM_AppMenu, MUIM_FindUData, ID_RESETSOCKS),
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, ObjectApp->WI_Main, 2,
         MUIM_CallHook, &ResetSocketsHook);


set(ObjectApp->TX_Port , MUIA_ShowMe, FALSE);
set(ObjectApp->TX_Timer, MUIA_ShowMe, FALSE);

return(ObjectApp);

}


void DisposeApp(struct ObjApp *ObjectApp)

{

MUI_DisposeObject(ObjectApp->App);
FreeVec(ObjectApp);

return;

}
